using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MyNamespace
{
	/// <summary>
	///		Configuration form for FlyAKite program
	///		Developed in TURBO Pascal 5.5 and 6.0, converted to Visual C# .Net
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class ConfigForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;

		public ConfigForm()
		{
			InitializeComponent();

			// no constructor logic
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ConfigForm));
			this.timerConfig = new System.Windows.Forms.Timer(this.components);
			this.labelH = new System.Windows.Forms.Label();
			this.labelLOW = new System.Windows.Forms.Label();
			this.labelFac1 = new System.Windows.Forms.Label();
			this.labelFac2 = new System.Windows.Forms.Label();
			this.labelLineN = new System.Windows.Forms.Label();
			this.labelLog = new System.Windows.Forms.Label();
			this.labelHomeDir = new System.Windows.Forms.Label();
			this.labelDataFile = new System.Windows.Forms.Label();
			this.labelLogFile = new System.Windows.Forms.Label();
			this.labelLogName = new System.Windows.Forms.Label();
			this.textBoxH = new System.Windows.Forms.TextBox();
			this.textBoxLOW = new System.Windows.Forms.TextBox();
			this.textBoxFac1 = new System.Windows.Forms.TextBox();
			this.textBoxFac2 = new System.Windows.Forms.TextBox();
			this.textBoxLineN = new System.Windows.Forms.TextBox();
			this.buttonH = new System.Windows.Forms.Button();
			this.buttonLOW = new System.Windows.Forms.Button();
			this.buttonFac1 = new System.Windows.Forms.Button();
			this.buttonFac2 = new System.Windows.Forms.Button();
			this.buttonLineN = new System.Windows.Forms.Button();
			this.buttonLog = new System.Windows.Forms.Button();
			this.buttonDataFile = new System.Windows.Forms.Button();
			this.buttonLogFile = new System.Windows.Forms.Button();
			this.buttonChangeDir = new System.Windows.Forms.Button();
			this.buttonExit = new System.Windows.Forms.Button();
			this.textBoxDataFile = new System.Windows.Forms.TextBox();
			this.textBoxLogFile = new System.Windows.Forms.TextBox();
			this.listBoxFile = new System.Windows.Forms.ListBox();
			this.folderBrowserDialogConfig = new System.Windows.Forms.FolderBrowserDialog();
			this.openFileDialogConfig = new System.Windows.Forms.OpenFileDialog();
			this.buttonSelectFile = new System.Windows.Forms.Button();
			this.labelSelectedFile = new System.Windows.Forms.Label();
			this.labelFilePath = new System.Windows.Forms.Label();
			this.labelLength = new System.Windows.Forms.Label();
			this.textBoxLength = new System.Windows.Forms.TextBox();
			this.buttonLength = new System.Windows.Forms.Button();
			this.labelTension = new System.Windows.Forms.Label();
			this.buttonTension = new System.Windows.Forms.Button();
			this.labelZeta = new System.Windows.Forms.Label();
			this.textBoxTension = new System.Windows.Forms.TextBox();
			this.textBoxZeta = new System.Windows.Forms.TextBox();
			this.buttonZeta = new System.Windows.Forms.Button();
			this.labelSa = new System.Windows.Forms.Label();
			this.textBoxSa = new System.Windows.Forms.TextBox();
			this.buttonSa = new System.Windows.Forms.Button();
			this.buttonLoad = new System.Windows.Forms.Button();
			this.buttonSave = new System.Windows.Forms.Button();
			this.buttonClear = new System.Windows.Forms.Button();
			this.buttonInsert = new System.Windows.Forms.Button();
			this.buttonDelete = new System.Windows.Forms.Button();
			this.buttonShow = new System.Windows.Forms.Button();
			this.buttonNext = new System.Windows.Forms.Button();
			this.buttonPrev = new System.Windows.Forms.Button();
			this.labelStart = new System.Windows.Forms.Label();
			this.textBoxStart = new System.Windows.Forms.TextBox();
			this.buttonStart = new System.Windows.Forms.Button();
			this.labelStop = new System.Windows.Forms.Label();
			this.textBoxStop = new System.Windows.Forms.TextBox();
			this.buttonStop = new System.Windows.Forms.Button();
			this.buttonCalc = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// timerConfig
			// 
			this.timerConfig.Enabled = true;
			this.timerConfig.Interval = 500;
			this.timerConfig.Tick += new System.EventHandler(this.timerConfig_Tick);
			// 
			// labelH
			// 
			this.labelH.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelH.Location = new System.Drawing.Point(96, 8);
			this.labelH.Name = "labelH";
			this.labelH.Size = new System.Drawing.Size(216, 16);
			this.labelH.TabIndex = 0;
			this.labelH.Text = "H = -9.99999999999999E+123";
			// 
			// labelLOW
			// 
			this.labelLOW.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelLOW.Location = new System.Drawing.Point(80, 32);
			this.labelLOW.Name = "labelLOW";
			this.labelLOW.Size = new System.Drawing.Size(232, 16);
			this.labelLOW.TabIndex = 1;
			this.labelLOW.Text = "L/W = -9.99999999999999E+123";
			// 
			// labelFac1
			// 
			this.labelFac1.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelFac1.Location = new System.Drawing.Point(48, 56);
			this.labelFac1.Name = "labelFac1";
			this.labelFac1.Size = new System.Drawing.Size(264, 16);
			this.labelFac1.TabIndex = 2;
			this.labelFac1.Text = "Factor1 = -9.99999999999999E+123";
			// 
			// labelFac2
			// 
			this.labelFac2.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelFac2.Location = new System.Drawing.Point(48, 80);
			this.labelFac2.Name = "labelFac2";
			this.labelFac2.Size = new System.Drawing.Size(264, 16);
			this.labelFac2.TabIndex = 3;
			this.labelFac2.Text = "Factor2 = -9.99999999999999E+123";
			// 
			// labelLineN
			// 
			this.labelLineN.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelLineN.Location = new System.Drawing.Point(56, 104);
			this.labelLineN.Name = "labelLineN";
			this.labelLineN.Size = new System.Drawing.Size(256, 16);
			this.labelLineN.TabIndex = 4;
			this.labelLineN.Text = "Line # = -9.99999999999999E+123";
			// 
			// labelLog
			// 
			this.labelLog.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelLog.Location = new System.Drawing.Point(120, 256);
			this.labelLog.Name = "labelLog";
			this.labelLog.Size = new System.Drawing.Size(144, 16);
			this.labelLog.TabIndex = 9;
			this.labelLog.Text = "Log to file mode:";
			// 
			// labelHomeDir
			// 
			this.labelHomeDir.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelHomeDir.Location = new System.Drawing.Point(32, 280);
			this.labelHomeDir.Name = "labelHomeDir";
			this.labelHomeDir.Size = new System.Drawing.Size(640, 16);
			this.labelHomeDir.TabIndex = 101;
			this.labelHomeDir.Text = "Home Dir: C:\\MMMMMMMMMMMM\\MMMMMMMMMM\\MMMMMMMMMMM\\MMMMMMMMM\\MMMMMM\\MMMMM";
			// 
			// labelDataFile
			// 
			this.labelDataFile.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelDataFile.Location = new System.Drawing.Point(16, 352);
			this.labelDataFile.Name = "labelDataFile";
			this.labelDataFile.Size = new System.Drawing.Size(456, 16);
			this.labelDataFile.TabIndex = 12;
			this.labelDataFile.Text = "Data File: <Not set>";
			// 
			// labelLogFile
			// 
			this.labelLogFile.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelLogFile.Location = new System.Drawing.Point(48, 392);
			this.labelLogFile.Name = "labelLogFile";
			this.labelLogFile.Size = new System.Drawing.Size(424, 16);
			this.labelLogFile.TabIndex = 13;
			this.labelLogFile.Text = "Log File: <Not set>";
			// 
			// labelLogName
			// 
			this.labelLogName.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelLogName.Location = new System.Drawing.Point(360, 256);
			this.labelLogName.Name = "labelLogName";
			this.labelLogName.Size = new System.Drawing.Size(312, 16);
			this.labelLogName.TabIndex = 17;
			this.labelLogName.Text = "Log File: NoName.txt";
			// 
			// textBoxH
			// 
			this.textBoxH.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBoxH.Location = new System.Drawing.Point(312, 8);
			this.textBoxH.Name = "textBoxH";
			this.textBoxH.Size = new System.Drawing.Size(184, 22);
			this.textBoxH.TabIndex = 1;
			this.textBoxH.Text = "";
			this.textBoxH.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxH_KeyDown);
			this.textBoxH.TextChanged += new System.EventHandler(this.textBoxH_TextChanged);
			// 
			// textBoxLOW
			// 
			this.textBoxLOW.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBoxLOW.Location = new System.Drawing.Point(312, 32);
			this.textBoxLOW.Name = "textBoxLOW";
			this.textBoxLOW.Size = new System.Drawing.Size(184, 22);
			this.textBoxLOW.TabIndex = 2;
			this.textBoxLOW.Text = "";
			this.textBoxLOW.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxLOW_KeyDown);
			this.textBoxLOW.TextChanged += new System.EventHandler(this.textBoxLOW_TextChanged);
			// 
			// textBoxFac1
			// 
			this.textBoxFac1.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBoxFac1.Location = new System.Drawing.Point(312, 56);
			this.textBoxFac1.Name = "textBoxFac1";
			this.textBoxFac1.Size = new System.Drawing.Size(184, 22);
			this.textBoxFac1.TabIndex = 3;
			this.textBoxFac1.Text = "";
			this.textBoxFac1.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxFac1_KeyDown);
			this.textBoxFac1.TextChanged += new System.EventHandler(this.textBoxFac1_TextChanged);
			// 
			// textBoxFac2
			// 
			this.textBoxFac2.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBoxFac2.Location = new System.Drawing.Point(312, 80);
			this.textBoxFac2.Name = "textBoxFac2";
			this.textBoxFac2.Size = new System.Drawing.Size(184, 22);
			this.textBoxFac2.TabIndex = 4;
			this.textBoxFac2.Text = "";
			this.textBoxFac2.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxFac2_KeyDown);
			this.textBoxFac2.TextChanged += new System.EventHandler(this.textBoxFac2_TextChanged);
			// 
			// textBoxLineN
			// 
			this.textBoxLineN.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBoxLineN.Location = new System.Drawing.Point(312, 104);
			this.textBoxLineN.Name = "textBoxLineN";
			this.textBoxLineN.Size = new System.Drawing.Size(184, 22);
			this.textBoxLineN.TabIndex = 5;
			this.textBoxLineN.Text = "";
			this.textBoxLineN.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxLineN_KeyDown);
			this.textBoxLineN.TextChanged += new System.EventHandler(this.textBoxLineN_TextChanged);
			// 
			// buttonH
			// 
			this.buttonH.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonH.Location = new System.Drawing.Point(496, 8);
			this.buttonH.Name = "buttonH";
			this.buttonH.Size = new System.Drawing.Size(96, 21);
			this.buttonH.TabIndex = 10;
			this.buttonH.Text = "Change It";
			this.buttonH.Click += new System.EventHandler(this.buttonH_Click);
			// 
			// buttonLOW
			// 
			this.buttonLOW.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonLOW.Location = new System.Drawing.Point(496, 32);
			this.buttonLOW.Name = "buttonLOW";
			this.buttonLOW.Size = new System.Drawing.Size(96, 21);
			this.buttonLOW.TabIndex = 11;
			this.buttonLOW.Text = "Change It";
			this.buttonLOW.Click += new System.EventHandler(this.buttonLOW_Click);
			// 
			// buttonFac1
			// 
			this.buttonFac1.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonFac1.Location = new System.Drawing.Point(496, 56);
			this.buttonFac1.Name = "buttonFac1";
			this.buttonFac1.Size = new System.Drawing.Size(96, 21);
			this.buttonFac1.TabIndex = 12;
			this.buttonFac1.Text = "Change It";
			this.buttonFac1.Click += new System.EventHandler(this.buttonFac1_Click);
			// 
			// buttonFac2
			// 
			this.buttonFac2.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonFac2.Location = new System.Drawing.Point(496, 80);
			this.buttonFac2.Name = "buttonFac2";
			this.buttonFac2.Size = new System.Drawing.Size(96, 21);
			this.buttonFac2.TabIndex = 13;
			this.buttonFac2.Text = "Change It";
			this.buttonFac2.Click += new System.EventHandler(this.buttonFac2_Click);
			// 
			// buttonLineN
			// 
			this.buttonLineN.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonLineN.Location = new System.Drawing.Point(496, 104);
			this.buttonLineN.Name = "buttonLineN";
			this.buttonLineN.Size = new System.Drawing.Size(96, 21);
			this.buttonLineN.TabIndex = 14;
			this.buttonLineN.Text = "Change It";
			this.buttonLineN.Click += new System.EventHandler(this.buttonLineN_Click);
			// 
			// buttonLog
			// 
			this.buttonLog.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonLog.Location = new System.Drawing.Point(264, 256);
			this.buttonLog.Name = "buttonLog";
			this.buttonLog.Size = new System.Drawing.Size(88, 21);
			this.buttonLog.TabIndex = 23;
			this.buttonLog.Text = "Is Off";
			this.buttonLog.Click += new System.EventHandler(this.buttonLog_Click);
			// 
			// buttonDataFile
			// 
			this.buttonDataFile.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonDataFile.Location = new System.Drawing.Point(120, 368);
			this.buttonDataFile.Name = "buttonDataFile";
			this.buttonDataFile.Size = new System.Drawing.Size(112, 21);
			this.buttonDataFile.TabIndex = 24;
			this.buttonDataFile.Text = "Change It";
			this.buttonDataFile.Click += new System.EventHandler(this.buttonDataFile_Click);
			// 
			// buttonLogFile
			// 
			this.buttonLogFile.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonLogFile.Location = new System.Drawing.Point(128, 408);
			this.buttonLogFile.Name = "buttonLogFile";
			this.buttonLogFile.Size = new System.Drawing.Size(104, 21);
			this.buttonLogFile.TabIndex = 25;
			this.buttonLogFile.Text = "Change It";
			this.buttonLogFile.Click += new System.EventHandler(this.buttonLogFile_Click);
			// 
			// buttonChangeDir
			// 
			this.buttonChangeDir.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonChangeDir.Location = new System.Drawing.Point(608, 32);
			this.buttonChangeDir.Name = "buttonChangeDir";
			this.buttonChangeDir.Size = new System.Drawing.Size(64, 48);
			this.buttonChangeDir.TabIndex = 38;
			this.buttonChangeDir.Text = "Change File Path";
			this.buttonChangeDir.Click += new System.EventHandler(this.buttonChangeDir_Click);
			// 
			// buttonExit
			// 
			this.buttonExit.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonExit.Location = new System.Drawing.Point(608, 176);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.Size = new System.Drawing.Size(64, 24);
			this.buttonExit.TabIndex = 40;
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			// 
			// textBoxDataFile
			// 
			this.textBoxDataFile.Location = new System.Drawing.Point(240, 368);
			this.textBoxDataFile.Name = "textBoxDataFile";
			this.textBoxDataFile.Size = new System.Drawing.Size(232, 22);
			this.textBoxDataFile.TabIndex = 26;
			this.textBoxDataFile.Text = "";
			this.textBoxDataFile.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxDataFile_KeyDown);
			this.textBoxDataFile.TextChanged += new System.EventHandler(this.textBoxDataFile_TextChanged);
			// 
			// textBoxLogFile
			// 
			this.textBoxLogFile.Location = new System.Drawing.Point(240, 408);
			this.textBoxLogFile.Name = "textBoxLogFile";
			this.textBoxLogFile.Size = new System.Drawing.Size(232, 22);
			this.textBoxLogFile.TabIndex = 27;
			this.textBoxLogFile.Text = "";
			this.textBoxLogFile.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxLogFile_KeyDown);
			this.textBoxLogFile.TextChanged += new System.EventHandler(this.textBoxLogFile_TextChanged);
			// 
			// listBoxFile
			// 
			this.listBoxFile.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.listBoxFile.ItemHeight = 16;
			this.listBoxFile.Location = new System.Drawing.Point(480, 328);
			this.listBoxFile.Name = "listBoxFile";
			this.listBoxFile.ScrollAlwaysVisible = true;
			this.listBoxFile.Size = new System.Drawing.Size(200, 212);
			this.listBoxFile.TabIndex = 37;
			this.listBoxFile.SelectedIndexChanged += new System.EventHandler(this.listBoxFile_SelectedIndexChanged);
			// 
			// openFileDialogConfig
			// 
			this.openFileDialogConfig.Title = "<Title ?>";
			// 
			// buttonSelectFile
			// 
			this.buttonSelectFile.Location = new System.Drawing.Point(608, 104);
			this.buttonSelectFile.Name = "buttonSelectFile";
			this.buttonSelectFile.Size = new System.Drawing.Size(64, 48);
			this.buttonSelectFile.TabIndex = 39;
			this.buttonSelectFile.Text = "Select a File";
			this.buttonSelectFile.Click += new System.EventHandler(this.buttonSelectFile_Click);
			// 
			// labelSelectedFile
			// 
			this.labelSelectedFile.Location = new System.Drawing.Point(120, 328);
			this.labelSelectedFile.Name = "labelSelectedFile";
			this.labelSelectedFile.Size = new System.Drawing.Size(352, 16);
			this.labelSelectedFile.TabIndex = 148;
			this.labelSelectedFile.Text = "Selected file: NoName.txt";
			// 
			// labelFilePath
			// 
			this.labelFilePath.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelFilePath.Location = new System.Drawing.Point(24, 304);
			this.labelFilePath.Name = "labelFilePath";
			this.labelFilePath.Size = new System.Drawing.Size(648, 16);
			this.labelFilePath.TabIndex = 110;
			this.labelFilePath.Text = "File path: C:\\MMMMMMMMMMMM\\MMMMMMMMMM\\MMMMMMMMMMM\\MMMMMMMMM\\MMMMMM\\MMMMM";
			// 
			// labelLength
			// 
			this.labelLength.Location = new System.Drawing.Point(56, 128);
			this.labelLength.Name = "labelLength";
			this.labelLength.Size = new System.Drawing.Size(256, 16);
			this.labelLength.TabIndex = 132;
			this.labelLength.Text = "Length = -9.99999999999999E+123";
			// 
			// textBoxLength
			// 
			this.textBoxLength.Location = new System.Drawing.Point(312, 128);
			this.textBoxLength.Name = "textBoxLength";
			this.textBoxLength.Size = new System.Drawing.Size(184, 22);
			this.textBoxLength.TabIndex = 6;
			this.textBoxLength.Text = "";
			this.textBoxLength.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxLength_KeyDown);
			this.textBoxLength.TextChanged += new System.EventHandler(this.textBoxLength_TextChanged);
			// 
			// buttonLength
			// 
			this.buttonLength.Location = new System.Drawing.Point(496, 128);
			this.buttonLength.Name = "buttonLength";
			this.buttonLength.Size = new System.Drawing.Size(96, 21);
			this.buttonLength.TabIndex = 15;
			this.buttonLength.Text = "Change It";
			this.buttonLength.Click += new System.EventHandler(this.buttonLength_Click);
			// 
			// labelTension
			// 
			this.labelTension.Location = new System.Drawing.Point(48, 152);
			this.labelTension.Name = "labelTension";
			this.labelTension.Size = new System.Drawing.Size(264, 16);
			this.labelTension.TabIndex = 135;
			this.labelTension.Text = "Tension = -9.99999999999999E+123";
			// 
			// buttonTension
			// 
			this.buttonTension.Location = new System.Drawing.Point(496, 152);
			this.buttonTension.Name = "buttonTension";
			this.buttonTension.Size = new System.Drawing.Size(96, 21);
			this.buttonTension.TabIndex = 16;
			this.buttonTension.Text = "Change It";
			this.buttonTension.Click += new System.EventHandler(this.buttonTension_Click);
			// 
			// labelZeta
			// 
			this.labelZeta.Location = new System.Drawing.Point(0, 176);
			this.labelZeta.Name = "labelZeta";
			this.labelZeta.Size = new System.Drawing.Size(312, 16);
			this.labelZeta.TabIndex = 138;
			this.labelZeta.Text = "Angle to Kite = -9.99999999999999E+123";
			// 
			// textBoxTension
			// 
			this.textBoxTension.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBoxTension.Location = new System.Drawing.Point(312, 152);
			this.textBoxTension.Name = "textBoxTension";
			this.textBoxTension.Size = new System.Drawing.Size(184, 22);
			this.textBoxTension.TabIndex = 7;
			this.textBoxTension.Text = "";
			this.textBoxTension.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxTension_KeyDown);
			this.textBoxTension.TextChanged += new System.EventHandler(this.textBoxTension_TextChanged);
			// 
			// textBoxZeta
			// 
			this.textBoxZeta.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBoxZeta.Location = new System.Drawing.Point(312, 176);
			this.textBoxZeta.Name = "textBoxZeta";
			this.textBoxZeta.Size = new System.Drawing.Size(184, 22);
			this.textBoxZeta.TabIndex = 8;
			this.textBoxZeta.Text = "";
			this.textBoxZeta.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxZeta_KeyDown);
			this.textBoxZeta.TextChanged += new System.EventHandler(this.textBoxZeta_TextChanged);
			// 
			// buttonZeta
			// 
			this.buttonZeta.Location = new System.Drawing.Point(496, 176);
			this.buttonZeta.Name = "buttonZeta";
			this.buttonZeta.Size = new System.Drawing.Size(96, 21);
			this.buttonZeta.TabIndex = 17;
			this.buttonZeta.Text = "Change It";
			this.buttonZeta.Click += new System.EventHandler(this.buttonZeta_Click);
			// 
			// labelSa
			// 
			this.labelSa.Location = new System.Drawing.Point(8, 200);
			this.labelSa.Name = "labelSa";
			this.labelSa.Size = new System.Drawing.Size(304, 16);
			this.labelSa.TabIndex = 141;
			this.labelSa.Text = "String angle = -9.99999999999999E+123";
			// 
			// textBoxSa
			// 
			this.textBoxSa.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBoxSa.Location = new System.Drawing.Point(312, 200);
			this.textBoxSa.Name = "textBoxSa";
			this.textBoxSa.Size = new System.Drawing.Size(184, 22);
			this.textBoxSa.TabIndex = 9;
			this.textBoxSa.Text = "";
			this.textBoxSa.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxSa_KeyDown);
			this.textBoxSa.TextChanged += new System.EventHandler(this.textBoxSa_TextChanged);
			// 
			// buttonSa
			// 
			this.buttonSa.Location = new System.Drawing.Point(496, 200);
			this.buttonSa.Name = "buttonSa";
			this.buttonSa.Size = new System.Drawing.Size(96, 21);
			this.buttonSa.TabIndex = 18;
			this.buttonSa.Text = "Change It";
			this.buttonSa.Click += new System.EventHandler(this.buttonSa_Click);
			// 
			// buttonLoad
			// 
			this.buttonLoad.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonLoad.Location = new System.Drawing.Point(32, 448);
			this.buttonLoad.Name = "buttonLoad";
			this.buttonLoad.Size = new System.Drawing.Size(104, 21);
			this.buttonLoad.TabIndex = 28;
			this.buttonLoad.Text = "Load Data";
			this.buttonLoad.Click += new System.EventHandler(this.buttonLoad_Click);
			// 
			// buttonSave
			// 
			this.buttonSave.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonSave.Location = new System.Drawing.Point(152, 448);
			this.buttonSave.Name = "buttonSave";
			this.buttonSave.Size = new System.Drawing.Size(104, 21);
			this.buttonSave.TabIndex = 29;
			this.buttonSave.Text = "Save Data";
			this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
			// 
			// buttonClear
			// 
			this.buttonClear.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonClear.Location = new System.Drawing.Point(272, 448);
			this.buttonClear.Name = "buttonClear";
			this.buttonClear.Size = new System.Drawing.Size(104, 21);
			this.buttonClear.TabIndex = 30;
			this.buttonClear.Text = "Clear Data";
			this.buttonClear.Click += new System.EventHandler(this.buttonClear_Click);
			// 
			// buttonInsert
			// 
			this.buttonInsert.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonInsert.Location = new System.Drawing.Point(32, 512);
			this.buttonInsert.Name = "buttonInsert";
			this.buttonInsert.Size = new System.Drawing.Size(104, 21);
			this.buttonInsert.TabIndex = 34;
			this.buttonInsert.Text = "Insert Line";
			this.buttonInsert.Click += new System.EventHandler(this.buttonInsert_Click);
			// 
			// buttonDelete
			// 
			this.buttonDelete.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonDelete.Location = new System.Drawing.Point(152, 512);
			this.buttonDelete.Name = "buttonDelete";
			this.buttonDelete.Size = new System.Drawing.Size(104, 21);
			this.buttonDelete.TabIndex = 35;
			this.buttonDelete.Text = "Delete Line";
			this.buttonDelete.Click += new System.EventHandler(this.buttonDelete_Click);
			// 
			// buttonShow
			// 
			this.buttonShow.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonShow.Location = new System.Drawing.Point(272, 480);
			this.buttonShow.Name = "buttonShow";
			this.buttonShow.Size = new System.Drawing.Size(104, 21);
			this.buttonShow.TabIndex = 33;
			this.buttonShow.Text = "Show Data";
			this.buttonShow.Click += new System.EventHandler(this.buttonShow_Click);
			// 
			// buttonNext
			// 
			this.buttonNext.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonNext.Location = new System.Drawing.Point(152, 480);
			this.buttonNext.Name = "buttonNext";
			this.buttonNext.Size = new System.Drawing.Size(104, 21);
			this.buttonNext.TabIndex = 32;
			this.buttonNext.Text = "Next Line";
			this.buttonNext.Click += new System.EventHandler(this.buttonNext_Click);
			// 
			// buttonPrev
			// 
			this.buttonPrev.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonPrev.Location = new System.Drawing.Point(32, 480);
			this.buttonPrev.Name = "buttonPrev";
			this.buttonPrev.Size = new System.Drawing.Size(104, 21);
			this.buttonPrev.TabIndex = 31;
			this.buttonPrev.Text = "Prev. Line";
			this.buttonPrev.Click += new System.EventHandler(this.buttonPrev_Click);
			// 
			// labelStart
			// 
			this.labelStart.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelStart.Location = new System.Drawing.Point(8, 232);
			this.labelStart.Name = "labelStart";
			this.labelStart.Size = new System.Drawing.Size(160, 16);
			this.labelStart.TabIndex = 152;
			this.labelStart.Text = "Start line = 100000";
			// 
			// textBoxStart
			// 
			this.textBoxStart.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBoxStart.Location = new System.Drawing.Point(168, 232);
			this.textBoxStart.Name = "textBoxStart";
			this.textBoxStart.Size = new System.Drawing.Size(72, 22);
			this.textBoxStart.TabIndex = 19;
			this.textBoxStart.Text = "";
			this.textBoxStart.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxStart_KeyDown);
			this.textBoxStart.TextChanged += new System.EventHandler(this.textBoxStart_TextChanged);
			// 
			// buttonStart
			// 
			this.buttonStart.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonStart.Location = new System.Drawing.Point(240, 232);
			this.buttonStart.Name = "buttonStart";
			this.buttonStart.Size = new System.Drawing.Size(96, 21);
			this.buttonStart.TabIndex = 20;
			this.buttonStart.Text = "Change It";
			this.buttonStart.Click += new System.EventHandler(this.buttonStart_Click);
			// 
			// labelStop
			// 
			this.labelStop.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelStop.Location = new System.Drawing.Point(352, 232);
			this.labelStop.Name = "labelStop";
			this.labelStop.Size = new System.Drawing.Size(152, 16);
			this.labelStop.TabIndex = 155;
			this.labelStop.Text = "Stop line = 100000";
			// 
			// textBoxStop
			// 
			this.textBoxStop.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBoxStop.Location = new System.Drawing.Point(504, 232);
			this.textBoxStop.Name = "textBoxStop";
			this.textBoxStop.Size = new System.Drawing.Size(72, 22);
			this.textBoxStop.TabIndex = 21;
			this.textBoxStop.Text = "";
			this.textBoxStop.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxStop_KeyDown);
			this.textBoxStop.TextChanged += new System.EventHandler(this.textBoxStop_TextChanged);
			// 
			// buttonStop
			// 
			this.buttonStop.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonStop.Location = new System.Drawing.Point(576, 232);
			this.buttonStop.Name = "buttonStop";
			this.buttonStop.Size = new System.Drawing.Size(96, 21);
			this.buttonStop.TabIndex = 22;
			this.buttonStop.Text = "Change It";
			this.buttonStop.Click += new System.EventHandler(this.buttonStop_Click);
			// 
			// buttonCalc
			// 
			this.buttonCalc.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonCalc.Location = new System.Drawing.Point(272, 512);
			this.buttonCalc.Name = "buttonCalc";
			this.buttonCalc.Size = new System.Drawing.Size(104, 21);
			this.buttonCalc.TabIndex = 36;
			this.buttonCalc.Text = "Calculate";
			this.buttonCalc.Click += new System.EventHandler(this.buttonCalc_Click);
			// 
			// ConfigForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(8, 15);
			this.ClientSize = new System.Drawing.Size(680, 550);
			this.Controls.Add(this.buttonCalc);
			this.Controls.Add(this.buttonStop);
			this.Controls.Add(this.textBoxStop);
			this.Controls.Add(this.textBoxStart);
			this.Controls.Add(this.textBoxSa);
			this.Controls.Add(this.textBoxZeta);
			this.Controls.Add(this.textBoxTension);
			this.Controls.Add(this.textBoxLength);
			this.Controls.Add(this.textBoxLogFile);
			this.Controls.Add(this.textBoxDataFile);
			this.Controls.Add(this.textBoxLineN);
			this.Controls.Add(this.textBoxFac2);
			this.Controls.Add(this.textBoxFac1);
			this.Controls.Add(this.textBoxLOW);
			this.Controls.Add(this.textBoxH);
			this.Controls.Add(this.labelStop);
			this.Controls.Add(this.buttonStart);
			this.Controls.Add(this.labelStart);
			this.Controls.Add(this.buttonPrev);
			this.Controls.Add(this.buttonNext);
			this.Controls.Add(this.buttonShow);
			this.Controls.Add(this.buttonDelete);
			this.Controls.Add(this.buttonInsert);
			this.Controls.Add(this.buttonClear);
			this.Controls.Add(this.buttonSave);
			this.Controls.Add(this.buttonLoad);
			this.Controls.Add(this.buttonSa);
			this.Controls.Add(this.labelSa);
			this.Controls.Add(this.buttonZeta);
			this.Controls.Add(this.labelZeta);
			this.Controls.Add(this.buttonTension);
			this.Controls.Add(this.labelTension);
			this.Controls.Add(this.buttonLength);
			this.Controls.Add(this.labelLength);
			this.Controls.Add(this.labelSelectedFile);
			this.Controls.Add(this.buttonSelectFile);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.buttonChangeDir);
			this.Controls.Add(this.buttonLogFile);
			this.Controls.Add(this.buttonDataFile);
			this.Controls.Add(this.buttonLog);
			this.Controls.Add(this.buttonLineN);
			this.Controls.Add(this.buttonFac2);
			this.Controls.Add(this.buttonFac1);
			this.Controls.Add(this.buttonLOW);
			this.Controls.Add(this.buttonH);
			this.Controls.Add(this.listBoxFile);
			this.Controls.Add(this.labelLogName);
			this.Controls.Add(this.labelLogFile);
			this.Controls.Add(this.labelDataFile);
			this.Controls.Add(this.labelFilePath);
			this.Controls.Add(this.labelHomeDir);
			this.Controls.Add(this.labelLog);
			this.Controls.Add(this.labelLineN);
			this.Controls.Add(this.labelFac2);
			this.Controls.Add(this.labelFac1);
			this.Controls.Add(this.labelLOW);
			this.Controls.Add(this.labelH);
			this.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "ConfigForm";
			this.Text = "ConfigForm";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.ConfigForm_Closing);
			this.ResumeLayout(false);

		}
		#endregion

		private System.Windows.Forms.Timer timerConfig;
		private System.Windows.Forms.Label labelH;
		private System.Windows.Forms.Label labelLOW;
		private System.Windows.Forms.Label labelFac1;
		private System.Windows.Forms.Label labelFac2;
		private System.Windows.Forms.Label labelLineN;
		private System.Windows.Forms.Label labelLog;
		private System.Windows.Forms.Label labelHomeDir;
		private System.Windows.Forms.Label labelDataFile;
		private System.Windows.Forms.Label labelLogFile;
		private System.Windows.Forms.Label labelLogName;
		private System.Windows.Forms.TextBox textBoxLOW;
		private System.Windows.Forms.TextBox textBoxFac1;
		private System.Windows.Forms.TextBox textBoxFac2;
		private System.Windows.Forms.TextBox textBoxLineN;
		private System.Windows.Forms.Button buttonH;
		private System.Windows.Forms.Button buttonLOW;
		private System.Windows.Forms.Button buttonFac1;
		private System.Windows.Forms.Button buttonFac2;
		private System.Windows.Forms.Button buttonLineN;
		private System.Windows.Forms.Button buttonDataFile;
		private System.Windows.Forms.Button buttonLogFile;
		private System.Windows.Forms.Button buttonChangeDir;
		private System.Windows.Forms.Button buttonExit;
		private System.Windows.Forms.TextBox textBoxDataFile;
		private System.Windows.Forms.TextBox textBoxLogFile;
		private System.Windows.Forms.Button buttonLog;
		private System.Windows.Forms.TextBox textBoxH;
		private System.Windows.Forms.ListBox listBoxFile;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialogConfig;
		private System.Windows.Forms.OpenFileDialog openFileDialogConfig;
		private System.Windows.Forms.Label labelSelectedFile;
		private System.Windows.Forms.Label labelFilePath;
		private System.Windows.Forms.Label labelLength;
		private System.Windows.Forms.TextBox textBoxLength;
		private System.Windows.Forms.Button buttonLength;
		private System.Windows.Forms.Label labelTension;
		private System.Windows.Forms.Button buttonTension;
		private System.Windows.Forms.Label labelZeta;
		private System.Windows.Forms.TextBox textBoxTension;
		private System.Windows.Forms.TextBox textBoxZeta;
		private System.Windows.Forms.Button buttonZeta;
		private System.Windows.Forms.Button buttonLoad;
		private System.Windows.Forms.Button buttonSave;
		private System.Windows.Forms.Button buttonClear;
		private System.Windows.Forms.Button buttonInsert;
		private System.Windows.Forms.Button buttonDelete;
		private System.Windows.Forms.Button buttonShow;
		private System.Windows.Forms.Button buttonNext;
		private System.Windows.Forms.Button buttonPrev;
		private System.Windows.Forms.Label labelStart;
		private System.Windows.Forms.TextBox textBoxStart;
		private System.Windows.Forms.Label labelStop;
		private System.Windows.Forms.TextBox textBoxStop;
		private System.Windows.Forms.Button buttonStart;
		private System.Windows.Forms.Button buttonStop;
		private System.Windows.Forms.Button buttonCalc;
		private System.Windows.Forms.Label labelSa;
		private System.Windows.Forms.TextBox textBoxSa;
		private System.Windows.Forms.Button buttonSa;
		private System.Windows.Forms.Button buttonSelectFile;

		// -------- Begin Main program, Configuration
		public void Config()
		{
			// don't allow Config form to be brought up more than once
			if (Common.configUp) { Dispose(true); return; }
			Common.configUp = true;
			this.Text = Global.title + " - Configuration/Edit";
			labelHomeDir.Text = "Home Dir: " + Common.homeDir;
			timerConfig_Tick();
			textBoxH.Focus();
			GetFileNames();
		}

		private void GetFileNames() // populate the listBoxFile with file names
		{
			try
			{
				DirectoryInfo di = new DirectoryInfo(Environment.CurrentDirectory);
				listBoxFile.Items.Clear();
				string filter = "*.txt";
				if (Common.selectFilter > 1) filter = "*.*";
				foreach (FileInfo FI in di.GetFiles(filter))
				{
					listBoxFile.Items.Add(FI.Name);
				}
			}
			catch (Exception ex)
			{
				Common.ReportError("GetFileNames:", ex.Message);
			}
		}

		private void buttonH_Click(object sender, System.EventArgs e)
		// change Max decimal digits allowed
		{
			buttonH_Click();
		}

		private void buttonH_Click()
		// change Integration step size H in feet
		{
			if (textBoxH.Text != "")		// if "", set to current
				FlyAKite.Param.h = Convert.ToDouble(textBoxH.Text);
			textBoxH.Text = FlyAKite.Param.h.ToString();
			DisplayH();
			textBoxH.Focus();
			textBoxH.SelectionStart = textBoxH.Text.Length;
		}

		private void buttonLOW_Click(object sender, System.EventArgs e)
		// change L/W
		{
			buttonLOW_Click();
		}

		private void buttonLOW_Click()
		// change L/W
		{
			if (textBoxLOW.Text != "")		// if "", set to current
				FlyAKite.Param.lOW = Convert.ToDouble(textBoxLOW.Text);
			textBoxLOW.Text = FlyAKite.Param.lOW.ToString();
			DisplayLOW();
			textBoxLOW.Focus();
			textBoxLOW.SelectionStart = textBoxLOW.Text.Length;
		}

		private void buttonFac1_Click(object sender, System.EventArgs e)
		// change digits per group in display
		{
			buttonFac1_Click();
		}

		private void buttonFac1_Click()	// change Factor1
		{
			if (textBoxFac1.Text != "")		// if "", set to current
				FlyAKite.Param.fac1 = Convert.ToDouble(textBoxFac1.Text);
			textBoxFac1.Text = FlyAKite.Param.fac1.ToString();
			DisplayFac1();
			textBoxFac1.Focus();
			textBoxFac1.SelectionStart = textBoxFac1.Text.Length;
		}

		private void buttonFac2_Click(object sender, System.EventArgs e) // change baseI
		{
			buttonFac2_Click();
		}

		private void buttonFac2_Click()	// change Factor2
		{
			if (textBoxFac2.Text != "")		// if "", set to current
				FlyAKite.Param.fac2 = Convert.ToDouble(textBoxFac2.Text);
			textBoxFac2.Text = FlyAKite.Param.fac2.ToString();
			DisplayFac2();
			textBoxFac2.Focus();
			textBoxFac2.SelectionStart = textBoxFac2.Text.Length;
		}

		private void buttonLineN_Click(object sender, System.EventArgs e) // change LineN
		{
			buttonLineN_Click();
		}

		private void buttonLineN_Click() // change LineN
		{
			if (textBoxLineN.Text != "")		// if "", set to current
				FlyAKite.Param.lineN = Convert.ToInt32(textBoxLineN.Text);
			textBoxLineN.Text = FlyAKite.Param.lineN.ToString();
			DisplayLineN();
			textBoxLineN.Focus();
			textBoxLineN.SelectionStart = textBoxLineN.Text.Length;
		}

		private void buttonLength_Click(object sender, System.EventArgs e)
		{
			buttonLength_Click();
		}

		private void buttonLength_Click()
		{
			double old = FlyAKite.Data[FlyAKite.Param.lineN].length;
			if (textBoxLength.Text != "")		// if "", set to current
				FlyAKite.Data[FlyAKite.Param.lineN].length = Convert.ToDouble(textBoxLength.Text);
			textBoxLength.Text = FlyAKite.Data[FlyAKite.Param.lineN].length.ToString();
			if (FlyAKite.Data[FlyAKite.Param.lineN].length != old) ZeroFactors();
			DisplayLength();
			textBoxLength.Focus();
			textBoxLength.SelectionStart = textBoxLength.Text.Length;
		}

		private void buttonTension_Click(object sender, System.EventArgs e)
		{
			buttonTension_Click();
		}

		private void buttonTension_Click()
		{
			double old = FlyAKite.Data[FlyAKite.Param.lineN].tension;
			if (textBoxTension.Text != "")		// if "", set to current
				FlyAKite.Data[FlyAKite.Param.lineN].tension = Convert.ToDouble(textBoxTension.Text);
			textBoxTension.Text = FlyAKite.Data[FlyAKite.Param.lineN].tension.ToString();
			if (FlyAKite.Data[FlyAKite.Param.lineN].tension != old) ZeroFactors();
			DisplayTension();
			textBoxTension.Focus();
			textBoxTension.SelectionStart = textBoxTension.Text.Length;
		}

		private void buttonZeta_Click(object sender, System.EventArgs e)
		{
			buttonZeta_Click();
		}

		private void buttonZeta_Click()
		{
			double old = FlyAKite.Data[FlyAKite.Param.lineN].zeta;
			if (textBoxZeta.Text != "")		// if "", set to current
				FlyAKite.Data[FlyAKite.Param.lineN].zeta = Convert.ToDouble(textBoxZeta.Text);
			textBoxZeta.Text = FlyAKite.Data[FlyAKite.Param.lineN].zeta.ToString();
			if (FlyAKite.Data[FlyAKite.Param.lineN].zeta != old) ZeroFactors();
			DisplayZeta();
			textBoxZeta.Focus();
			textBoxZeta.SelectionStart = textBoxZeta.Text.Length;
		}

		private void buttonSa_Click(object sender, System.EventArgs e)
		{
			buttonSa_Click();
		}

		private void buttonSa_Click()
		{
			double old = FlyAKite.Data[FlyAKite.Param.lineN].sA;
			if (textBoxSa.Text != "")		// if "", set to current
				FlyAKite.Data[FlyAKite.Param.lineN].sA = Convert.ToDouble(textBoxSa.Text);
			textBoxSa.Text = FlyAKite.Data[FlyAKite.Param.lineN].sA.ToString();
			if (FlyAKite.Data[FlyAKite.Param.lineN].sA != old) ZeroFactors();
			DisplaySa();
			textBoxSa.Focus();
			textBoxSa.SelectionStart = textBoxSa.Text.Length;
		}

		private void buttonStart_Click(object sender, System.EventArgs e)
		{
			buttonStart_Click();
		}

		private void buttonStart_Click()
		{
			if (textBoxStart.Text != "")		// if "", set to current
				FlyAKite.Param.start = Convert.ToInt32(textBoxStart.Text);
			textBoxStart.Text = FlyAKite.Param.start.ToString();
			DisplayStart();
			textBoxStart.Focus();
			textBoxStart.SelectionStart = textBoxStart.Text.Length;
		}

		private void buttonStop_Click(object sender, System.EventArgs e)
		{
			buttonStop_Click();
		}

		private void buttonStop_Click()
		{
			if (textBoxStop.Text != "")		// if "", set to current
				FlyAKite.Param.stop = Convert.ToInt32(textBoxStop.Text);
			textBoxStop.Text = FlyAKite.Param.stop.ToString();
			DisplayStop();
			textBoxStop.Focus();
			textBoxStop.SelectionStart = textBoxStop.Text.Length;
		}

		private void buttonLoad_Click(object sender, System.EventArgs e)
		{
			RunForm.buttonLoad_Click();
			buttonLoad.Focus();
		}

		private void buttonSave_Click(object sender, System.EventArgs e)
		// save all data in memory to disk files
		{
			StreamWriter outF; // text file, for data
			string savDir = Environment.CurrentDirectory.ToString();
			Directory.SetCurrentDirectory(Common.homeDir);
			string fName = Common.dataFile;
			if (fName == "") fName = "Data.txt";
			if (Common.ChkWrite(out outF, fName, ""))
			{
				buttonSave.Focus();
				try { outF.WriteLine(Global.title + ", " + Global.version); }
				catch { goto endif; }
				if (Global.system != "") outF.WriteLine("Run on: " + Global.system);
				DateTimePicker dateTime = new System.Windows.Forms.DateTimePicker();
				string dateTimeString = dateTime.Value.ToString();
				Common.WriteLn(null, outF);
				Common.Write(null, outF, "Flight data file " + Common.dataFile);
				Common.WriteLn2(null, outF, ", " + dateTimeString);
				RunForm.OutputData(null, outF);
				Common.WriteLn2(null, outF, "EOF");
				outF.Close();
			}
endif:
			Directory.SetCurrentDirectory(savDir);
		} // buttonSave_Click

		private void buttonClear_Click(object sender, System.EventArgs e)
		{
			FlyAKite.Param.lines = 1;
			FlyAKite.Param.lineN = 1;
		
		}

		private void buttonNext_Click(object sender, System.EventArgs e)
		{
			if(FlyAKite.Param.lineN < FlyAKite.Param.lines)
				FlyAKite.Param.lineN++;
			else
				FlyAKite.Param.lineN = 1;
		}

		private void buttonPrev_Click(object sender, System.EventArgs e)
		{
			if(FlyAKite.Param.lineN > 1)
				FlyAKite.Param.lineN--;
			else
				FlyAKite.Param.lineN = FlyAKite.Param.lines;
		}

		private void buttonShow_Click(object sender, System.EventArgs e)
		{
			RunForm.buttonShowData_Click();
		}

		private void buttonInsert_Click(object sender, System.EventArgs e)
		{
			FlyAKite.Param.lines++;
			FlyAKite.Param.lineN++;
			for (int i = FlyAKite.Param.lines; i >= FlyAKite.Param.lineN; i--)
			{
				FlyAKite.Data[i].length = FlyAKite.Data[i-1].length;
				FlyAKite.Data[i].tension = FlyAKite.Data[i-1].tension;
				FlyAKite.Data[i].zeta = FlyAKite.Data[i-1].zeta;
				FlyAKite.Data[i].sA = FlyAKite.Data[i-1].sA;
				FlyAKite.Data[i].factor = FlyAKite.Data[i-1].factor;
				FlyAKite.Data[i].xKite = FlyAKite.Data[i-1].xKite;
				FlyAKite.Data[i].yKite = FlyAKite.Data[i-1].yKite;
			}
		}

		private void buttonDelete_Click(object sender, System.EventArgs e)
		{
			if (FlyAKite.Param.lines < 2) return;
			for (int i = FlyAKite.Param.lineN; i < FlyAKite.Param.lines; i++)
			{
				FlyAKite.Data[i].length = FlyAKite.Data[i+1].length;
				FlyAKite.Data[i].tension = FlyAKite.Data[i+1].tension;
				FlyAKite.Data[i].zeta = FlyAKite.Data[i+1].zeta;
				FlyAKite.Data[i].sA = FlyAKite.Data[i+1].sA;
				FlyAKite.Data[i].factor = FlyAKite.Data[i+1].factor;
				FlyAKite.Data[i].xKite = FlyAKite.Data[i+1].xKite;
				FlyAKite.Data[i].yKite = FlyAKite.Data[i+1].yKite;
			}	
			FlyAKite.Param.lines--;
			if (FlyAKite.Param.lineN > 1)
				FlyAKite.Param.lineN--;
		}

		private void buttonChangeDir_Click(object sender, System.EventArgs e)
		// bring up folderBrowserDialog
		{
			folderBrowserDialogConfig.SelectedPath = Environment.CurrentDirectory;
			folderBrowserDialogConfig.Description = Global.title + " - Select a file path";
			folderBrowserDialogConfig.ShowDialog();
			Directory.SetCurrentDirectory(folderBrowserDialogConfig.SelectedPath);
			Common.selectPath = Environment.CurrentDirectory;
			GetFileNames();
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		// exit Configuration form
		{
			Common.configUp = false;
			Dispose(true);
		}

		private void buttonLog_Click(object sender, System.EventArgs e)
		// toggle Logging of output screen to Log File
		{
			Common.ToggleLogg();
			DisplayLog();
			buttonLog.Focus();
		}

		private void buttonSelectFile_Click(object sender, System.EventArgs e)
		// bring up openFileDialog
		{
			string st = Environment.CurrentDirectory.ToString();
			openFileDialogConfig.Reset();	// Reset needed to be able to change InitialDirectory
			openFileDialogConfig.InitialDirectory = st;
			openFileDialogConfig.Filter = "XICalc files (txt files (*.txt)|*.txt|All files(*.*)|*.*";
			openFileDialogConfig.FilterIndex = Common.selectFilter;
			openFileDialogConfig.RestoreDirectory = false;
			openFileDialogConfig.Title = Global.title + " - Select a file";
			if(openFileDialogConfig.ShowDialog() == DialogResult.OK)
			{
				st = openFileDialogConfig.FileName.ToString();
 				int i = st.LastIndexOf(@"\");					// seperate selected path and file strings
				Common.selectPath = st.Substring(0, i);
				Common.selectFile = st.Substring(i+1);
				Directory.SetCurrentDirectory(Common.selectPath);
				labelSelectedFile.Text = "Selected file: " + Common.selectFile;
			}
			Common.selectFilter = openFileDialogConfig.FilterIndex;
			GetFileNames();
		}

		private void buttonDataFile_Click(object sender, System.EventArgs e)
		// change name data file
		{
			buttonDataFile_Click();
		}

		private void buttonDataFile_Click()
		// change name of data file
		{
			Common.DoubleSpace();
			string st = textBoxDataFile.Text;
			if (st != "")
			{
				Common.FixFName(ref st, "txt");
				textBoxDataFile.Text = st;
				Common.dataFile = st;
			}
			else
			{
				if (Common.selectFile == "")
				{
					if (Common.dataFile != "") textBoxDataFile.Text = Common.dataFile;
				}
				else
				{
					textBoxDataFile.Text = Common.selectFile;
				}
			}
			DisplayDataFile();
			RunForm.FocusBothUs();
			textBoxDataFile.Focus();
			textBoxDataFile.SelectionStart = textBoxDataFile.Text.Length;
		}

		private void buttonLogFile_Click(object sender, System.EventArgs e)
		// change name of output log file
		{
			buttonLogFile_Click();
		}

		private void buttonLogFile_Click()
		// change name of output log file
		{
			Common.DoubleSpace();
			string st = textBoxLogFile.Text;
			if (st != "")
			{
				Common.FixFName(ref st, "txt");
				textBoxLogFile.Text = st;
				Common.logFile = st;
			}
			else
			{
				if (Common.selectFile == "")
				{
					if (Common.logFile != "") textBoxLogFile.Text = Common.logFile;
				}
				else
				{
					textBoxLogFile.Text = Common.selectFile;
				}
			}
			DisplayLogFile();
			RunForm.FocusBothUs();
			textBoxLogFile.Focus();
			textBoxLogFile.SelectionStart = textBoxLogFile.Text.Length;
		}

		private void DisplayH() // display integration step size
		{
			labelH.Text = "H = " + FlyAKite.Param.h;
		}

		private void DisplayLOW() // display L/W
		{
			labelLOW.Text = "L/W = " + FlyAKite.Param.lOW;
		}

		private void DisplayFac1() // display Factor1
		{
			labelFac1.Text = "Factor1 = " + FlyAKite.Param.fac1;
		}

		private void DisplayFac2() // display Factor2
		{
			labelFac2.Text = "Factor2 = " + FlyAKite.Param.fac2;
		}

		private void DisplayLineN() // display Current Line number
		{
			labelLineN.Text = "Line # = " + FlyAKite.Param.lineN + " of " + FlyAKite.Param.lines;

		}

		private void DisplayLength() // display length
		{
			labelLength.Text = "Length = " + FlyAKite.Data[FlyAKite.Param.lineN].length;
		}

		private void DisplayTension() // display tension
		{
			labelTension.Text = "Tension = " + FlyAKite.Data[FlyAKite.Param.lineN].tension;
		}

		private void DisplayZeta() // display length
		{
			labelZeta.Text = "Angle to Kite = " + FlyAKite.Data[FlyAKite.Param.lineN].zeta;
		}

		private void DisplaySa() // display length
		{
			labelSa.Text = "String angle = " + FlyAKite.Data[FlyAKite.Param.lineN].sA;
		}

		private void DisplayStart() // display start
		{
			labelStart.Text = "Start line = " + FlyAKite.Param.start;
		}

		private void DisplayStop() // display stop
		{
			labelStop.Text = "Stop line = " + FlyAKite.Param.stop;
		}

		private void DisplayLog() // display Log to file mode: On/Off
		{
			if (Common.logg)
				buttonLog.Text = "Is On";
			else
				buttonLog.Text = "Is Off";
		}

		private void DisplayLogName() // display name of open log file
		{
			if (Common.logg)
				labelLogName.Text = "Log File: " + Common.logFile;
			else
				labelLogName.Text = "";
		}

		private void DisplayDataFile() // display name of data file
		{
			string st = Common.dataFile;
			if (st == "") st = "<Not set>";
			labelDataFile.Text = "Data File: " + st;
		}

		private void DisplayLogFile() // display name of Output Log file
		{
			string st = Common.logFile;
			if (st == "") st = "<Not set>";
			labelLogFile.Text = "Log File: " + st;
		}

		private void listBoxFile_SelectedIndexChanged(object sender, System.EventArgs e)
		// save the selected file name
		{
			int i = listBoxFile.SelectedIndex;
			Common.selectFile = listBoxFile.Items[i].ToString();
		}

		private void textBoxH_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in H box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonH.Enabled) buttonH_Click();
			}
			if (e.KeyCode == Keys.Escape) // ESC key pressed so exit ConfigForm
			{
				Common.configUp = false;
				Dispose(true);
			}
		}

		private void textBoxLOW_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in LOW box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonLOW.Enabled) buttonLOW_Click();
			}
		}

		private void textBoxFac1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in Factor1 box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonFac1.Enabled) buttonFac1_Click();
			}
		}

		private void textBoxFac2_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in Factor2 box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonFac2.Enabled) buttonFac2_Click();
			}
		}

		private void textBoxLineN_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in Line number box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonLineN.Enabled) buttonLineN_Click();
			}
		}

		private void textBoxLength_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in Length box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonLength.Enabled) buttonLength_Click();
			}
		}

		private void textBoxTension_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in Tension box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonTension.Enabled) buttonTension_Click();
			}
		}

		private void textBoxZeta_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in Zeta box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonZeta.Enabled) buttonZeta_Click();
			}
		}

		private void textBoxSa_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in Sa box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonSa.Enabled) buttonSa_Click();
			}
		}

		private void textBoxStart_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonStart.Enabled) buttonStart_Click();
			}
		}

		private void textBoxStop_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonStop.Enabled) buttonStop_Click();
			}
		}

		private void textBoxDataFile_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in XPCIn box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonDataFile.Enabled) buttonDataFile_Click();
			}
		}

		private void textBoxLogFile_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in LogFile box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonLogFile.Enabled) buttonLogFile_Click();
			}
		}

		private void textBoxH_TextChanged(object sender, System.EventArgs e)
		// process input of H
		{
			if (Common.running) return;	// don't allow a change when integration is running
			textBoxH.Text = textBoxH.Text.TrimStart(' ');	// remove leading spaces
			if (textBoxH.Text == "")
			{
				buttonH.Enabled = true;
				return;
			}
			string sNum = textBoxH.Text;
			buttonH.Enabled = Global.IsDouble(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxH.Text = textBoxH.Text.Trim(' ');			// remove trailing spaces
					textBoxH.SelectionStart = textBoxH.Text.Length;		// move to right end of input
					if (buttonH.Enabled) buttonH_Click();				// accept the input
				}
			}
		}

		private void textBoxLOW_TextChanged(object sender, System.EventArgs e)
		// process input of L/W
		{
			if (Common.running) return;	// don't allow a change when integration is running
			textBoxLOW.Text = textBoxLOW.Text.TrimStart(' ');	// remove leading spaces
			if (textBoxLOW.Text == "")
			{
				buttonLOW.Enabled = true;
				return;
			}
			string sNum = textBoxLOW.Text;
			buttonLOW.Enabled = Global.IsDouble(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxLOW.Text = textBoxLOW.Text.Trim(' ');			// remove trailing spaces
					textBoxLOW.SelectionStart = textBoxLOW.Text.Length;		// move to right end of input
					if (buttonLOW.Enabled) buttonLOW_Click();				// accept the input
				}
			}
		}

		private void textBoxFac1_TextChanged(object sender, System.EventArgs e)
		// process input of Factor1
		{
			if (Common.running) return;	// don't allow a change when integration is running
			textBoxFac1.Text = textBoxFac1.Text.TrimStart(' ');	// remove leading spaces
			if (textBoxFac1.Text == "")
			{
				buttonFac1.Enabled = true;
				return;
			}
			string sNum = textBoxFac1.Text;
			buttonFac1.Enabled = Global.IsDouble(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxFac1.Text = textBoxFac1.Text.Trim(' ');			// remove trailing spaces
					textBoxFac1.SelectionStart = textBoxFac1.Text.Length;	// move to right end of input
					if (buttonFac1.Enabled) buttonFac1_Click();				// accept the input
				}
			}
		}

		private void textBoxFac2_TextChanged(object sender, System.EventArgs e)
		// process input of Factor2
		{
			if (Common.running) return;	// don't allow a change when integration is running
			textBoxFac2.Text = textBoxFac2.Text.TrimStart(' ');	// remove leading spaces
			if (textBoxFac2.Text == "")
			{
				buttonFac2.Enabled = true;
				return;
			}
			string sNum = textBoxFac2.Text;
			buttonFac2.Enabled = Global.IsDouble(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxFac2.Text = textBoxFac2.Text.Trim(' ');			// remove trailing spaces
					textBoxFac2.SelectionStart = textBoxFac2.Text.Length;	// move to right end of input
					if (buttonFac2.Enabled) buttonFac2_Click();				// accept the input
				}
			}
		}

		private void textBoxLineN_TextChanged(object sender, System.EventArgs e)
		// process input of Line number
		{
			if (Common.running) return;	// don't allow a change when integration is running
			textBoxLineN.Text = textBoxLineN.Text.TrimStart(' ');	// remove leading spaces
			if (textBoxLineN.Text == "")
			{
				buttonLineN.Enabled = true;
				return;
			}
			string sNum = textBoxLineN.Text;
			if (Global.IsInt32(sNum))
			{
				int iNum = Convert.ToInt32(sNum);
				buttonLineN.Enabled = ((1 <= iNum) &  (iNum <= FlyAKite.Param.lines)); // and iNum ok
			}
			else
			{
				buttonLineN.Enabled = false;
			}
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxLineN.Text = textBoxLineN.Text.Trim(' ');			// remove trailing spaces
					textBoxLineN.SelectionStart = textBoxLineN.Text.Length;	// move to right end of input
					if (buttonLineN.Enabled) buttonLineN_Click();				// accept the input
				}
			}
		}

		private void textBoxLength_TextChanged(object sender, System.EventArgs e)
		// process input of Length
		{
			if (Common.running) return;	// don't allow a change when integration is running
			textBoxLength.Text = textBoxLength.Text.TrimStart(' ');	// remove leading spaces
			if (textBoxLength.Text == "")
			{
				buttonLength.Enabled = true;
				return;
			}
			string sNum = textBoxLength.Text;
			buttonLength.Enabled = Global.IsDouble(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxLength.Text = textBoxLength.Text.Trim(' ');			// remove trailing spaces
					textBoxLength.SelectionStart = textBoxLength.Text.Length;	// move to right end of input
					if (buttonLength.Enabled) buttonLength_Click();				// accept the input
				}
			}
		}

		private void textBoxTension_TextChanged(object sender, System.EventArgs e)
		// process input of Tension
		{
			if (Common.running) return;	// don't allow a change when integration is running
			textBoxTension.Text = textBoxTension.Text.TrimStart(' ');	// remove leading spaces
			if (textBoxTension.Text == "")
			{
				buttonTension.Enabled = true;
				return;
			}
			string sNum = textBoxTension.Text;
			buttonTension.Enabled = Global.IsDouble(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxTension.Text = textBoxTension.Text.Trim(' ');			// remove trailing spaces
					textBoxTension.SelectionStart = textBoxTension.Text.Length;	// move to right end of input
					if (buttonTension.Enabled) buttonTension_Click();				// accept the input
				}
			}
		}

		private void textBoxZeta_TextChanged(object sender, System.EventArgs e)
		// process input of Zeta
		{
			if (Common.running) return;	// don't allow a change when integration is running
			textBoxZeta.Text = textBoxZeta.Text.TrimStart(' ');	// remove leading spaces
			if (textBoxZeta.Text == "")
			{
				buttonZeta.Enabled = true;
				return;
			}
			string sNum = textBoxZeta.Text;
			if (Global.IsDouble(sNum))
			{
				double dNum = Convert.ToDouble(sNum);
				buttonZeta.Enabled = (-360.0 <= dNum && dNum <= 360.0);
			}
			else
			{
				buttonZeta.Enabled = false;
			}
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxZeta.Text = textBoxZeta.Text.Trim(' ');			// remove trailing spaces
					textBoxZeta.SelectionStart = textBoxZeta.Text.Length;	// move to right end of input
					if (buttonZeta.Enabled) buttonZeta_Click();				// accept the input
				}
			}
		}

		private void textBoxSa_TextChanged(object sender, System.EventArgs e)
		// process input of Sa
		{
			if (Common.running) return;	// don't allow a change when integration is running
			textBoxSa.Text = textBoxSa.Text.TrimStart(' ');	// remove leading spaces
			if (textBoxSa.Text == "")
			{
				buttonSa.Enabled = true;
				return;
			}
			string sNum = textBoxSa.Text;
			buttonSa.Enabled = Global.IsDouble(sNum);
			if (Global.IsDouble(sNum))
			{
				double dNum = Convert.ToDouble(sNum);
				buttonSa.Enabled = (-360.0 <= dNum && dNum <= 360.0);
			}
			else
			{
				buttonSa.Enabled = false;
			}
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxSa.Text = textBoxSa.Text.Trim(' ');		// remove trailing spaces
					textBoxSa.SelectionStart = textBoxSa.Text.Length;	// move to right end of input
					if (buttonSa.Enabled) buttonSa_Click();			// accept the input
				}
			}
		}

		private void textBoxStart_TextChanged(object sender, System.EventArgs e)
		{
			if (Common.running) return;	// don't allow a change when integration is running
			textBoxStart.Text = textBoxStart.Text.TrimStart(' ');	// remove leading spaces
			if (textBoxStart.Text == "")
			{
				buttonStart.Enabled = true;
				return;
			}
			string sNum = textBoxStart.Text;
			if (Global.IsInt32(sNum))
			{
				int iNum = Convert.ToInt32(sNum);
				buttonStart.Enabled = ((1 <= iNum) &  (iNum <= FlyAKite.Param.maxFlights)); // and iNum ok
			}
			else
			{
				buttonStart.Enabled = false;
			}
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxStart.Text = textBoxStart.Text.Trim(' ');		// remove trailing spaces
					textBoxStart.SelectionStart = textBoxStart.Text.Length;	// move to right end of input
					if (buttonStart.Enabled) buttonStart_Click();			// accept the input
				}
			}
		}

		private void textBoxStop_TextChanged(object sender, System.EventArgs e)
		{
			if (Common.running) return;	// don't allow a change when integration is running
			textBoxStop.Text = textBoxStop.Text.TrimStart(' ');	// remove leading spaces
			if (textBoxStop.Text == "")
			{
				buttonStop.Enabled = true;
				return;
			}
			string sNum = textBoxStop.Text;
			if (Global.IsInt32(sNum))
			{
				int iNum = Convert.ToInt32(sNum);
				buttonStop.Enabled = ((1 <= iNum) &  (iNum <= FlyAKite.Param.maxFlights)); // and iNum ok
			}
			else
			{
				buttonStop.Enabled = false;
			}
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxStop.Text = textBoxStop.Text.Trim(' ');		// remove trailing spaces
					textBoxStop.SelectionStart = textBoxStop.Text.Length;	// move to right end of input
					if (buttonStop.Enabled) buttonStop_Click();			// accept the input
				}
			}
		}

		private void textBoxDataFile_TextChanged(object sender, System.EventArgs e)
		// process input of name of calculator code file
		{
			int n;
			string st;
			if (Common.running) return; // don't allow a change when Calc is running
			textBoxDataFile.Text = textBoxDataFile.Text.TrimStart(' '); // remove leading spaces
			st = textBoxDataFile.Text;
			n = st.Length;
			if (n == 0)
			{
				buttonDataFile.Enabled = true;
				return;
			}
			if (st[n-1] == ' ') // if space at right end of field
			{
				textBoxDataFile.Text = textBoxDataFile.Text.Trim(' ');		// remove trailing spaces
				textBoxDataFile.SelectionStart = textBoxDataFile.Text.Length; // move to right end of input
				if (buttonDataFile.Enabled) buttonDataFile_Click();			// accept the input
			}
		}

		private void textBoxLogFile_TextChanged(object sender, System.EventArgs e)
		// process input of name of output log file
		{
			int n;
			string st;
			if (Common.running) return; // don't allow a change when Calc is running
			textBoxLogFile.Text = textBoxLogFile.Text.TrimStart(' '); // remove leading spaces
			st = textBoxLogFile.Text;
			n = st.Length;
			if (n == 0)
			{
				buttonLogFile.Enabled = true;
				return;
			}
			if (st[n-1] == ' ') // if space at right end of field
			{
				textBoxLogFile.Text = textBoxLogFile.Text.Trim(' ');			// remove trailing spaces
				textBoxLogFile.SelectionStart = textBoxLogFile.Text.Length;	// move to right end of input
				if (buttonLogFile.Enabled) buttonLogFile_Click();				// accept the input
			}
		}

		private void timerConfig_Tick(object sender, System.EventArgs e)
		// update display of changeable items
		{
			if (!Global.runFormUp)
			{
				Common.configUp = false;
				Dispose(true);
				return;
			}
			timerConfig_Tick();
		}

		private void timerConfig_Tick()	// update display of changeable items
		{
			DisplayH();
			DisplayLOW();
			DisplayFac1();
			DisplayFac2();
			DisplayLineN();
			DisplayLength();
			DisplayTension();
			DisplayZeta();
			DisplaySa();
			DisplayStart();
			DisplayStop();
			DisplayLog();
			labelFilePath.Text = "File path: " + Environment.CurrentDirectory.ToString();
			labelSelectedFile.Text = "Selected file: " + Common.selectFile;
			DisplayDataFile();
			DisplayLogFile();
			DisplayLogName();
			if (Common.running)
			{
				buttonChangeDir.Enabled = false;
				buttonDataFile.Enabled = false;
				buttonLogFile.Enabled = false;
			}
			else
			{
				buttonChangeDir.Enabled = true;
				buttonDataFile.Enabled = true;
				buttonLogFile.Enabled = true;
			}
		} // timerConfig_Tick

		private void buttonCalc_Click(object sender, System.EventArgs e)
		{
			RunForm.Calculate();
		}

		private void ZeroFactors()
		{
			FlyAKite.Data[FlyAKite.Param.lineN].factor = 0.0;
			FlyAKite.Data[FlyAKite.Param.lineN].xKite = 0.0;
			FlyAKite.Data[FlyAKite.Param.lineN].yKite = 0.0;
		}

		private void ConfigForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		// exit Configuration form
		{
			Common.configUp = false;
		}
	}
}
