using System;
using System.Drawing;
using System.Windows.Forms;

namespace MyNamespace
{
	/// <summary>
	/// PlotForm is the Windows Form Component for testing the plotting functions in C#
	/// Developed by Michael Gold in 2002 and modified by Harry J. Smith in 2005
	/// See C# Corner at: http://www.c-sharpcorner.com/Code/2002/Aug/XYPlotControl.asp
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>
	public class PlotForm : System.Windows.Forms.Form
	{
		private PlotControl PlotControlXY;
		private System.Windows.Forms.Label labelStartX;
		private System.Windows.Forms.Button buttonStartX;
		private System.Windows.Forms.TextBox textBoxStartX;
		private System.Windows.Forms.Label labelStopX;
		private System.Windows.Forms.Button buttonStopX;
		private System.Windows.Forms.TextBox textBoxStopX;
		private System.Windows.Forms.Label labelStartY;
		private System.Windows.Forms.Button buttonStartY;
		private System.Windows.Forms.TextBox textBoxStartY;
		private System.Windows.Forms.Button buttonExit;
		private System.ComponentModel.IContainer components;

		private static float pi = 4.0f * (float)Math.Atan(1.0);
		private static float pi2 = 2.0f * pi;
		private static float dPR = 180f / pi;
		private static float large = 3.40282347E38f;

		private float startX; // not static, one set for each instance of PlotForm
		private float stopX;
		private float startY;
		private double maxX;
		private double minY;
		private int flightNo;

		private System.Windows.Forms.Button buttonAbout;
		private System.Windows.Forms.Button buttonSinCos;
		private System.Windows.Forms.Button buttonSinVsCos;
		private System.Windows.Forms.Button buttonPlotKite;
		private System.Windows.Forms.Label labelFlightNo;
		private System.Windows.Forms.TextBox textBoxFlightNo;
		private System.Windows.Forms.Button buttonFlightNo;
		private System.Windows.Forms.Button buttonAuto;
		private System.Windows.Forms.Timer timerPlot;
		private System.Windows.Forms.Button buttonPrev;
		private System.Windows.Forms.Button buttonNext;
		private System.Windows.Forms.Button buttonLoad;
		public static Screen screen;

		public PlotForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.Text = Global.title + " - Plot";
			textBoxStartX.Text = "-20000";
			buttonStartX_Click();
			textBoxStopX.Text = "10000";
			buttonStopX_Click();
			textBoxStartY.Text = "-4000";
			buttonStartY_Click();
			textBoxFlightNo.Text = FlyAKite.Param.lines.ToString();
			buttonFlightNo_Click();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PlotForm));
			this.buttonSinCos = new System.Windows.Forms.Button();
			this.PlotControlXY = new MyNamespace.PlotControl();
			this.buttonSinVsCos = new System.Windows.Forms.Button();
			this.labelStartX = new System.Windows.Forms.Label();
			this.buttonStartX = new System.Windows.Forms.Button();
			this.textBoxStartX = new System.Windows.Forms.TextBox();
			this.labelStopX = new System.Windows.Forms.Label();
			this.buttonStopX = new System.Windows.Forms.Button();
			this.textBoxStopX = new System.Windows.Forms.TextBox();
			this.buttonStartY = new System.Windows.Forms.Button();
			this.textBoxStartY = new System.Windows.Forms.TextBox();
			this.buttonExit = new System.Windows.Forms.Button();
			this.buttonAbout = new System.Windows.Forms.Button();
			this.buttonPlotKite = new System.Windows.Forms.Button();
			this.labelStartY = new System.Windows.Forms.Label();
			this.labelFlightNo = new System.Windows.Forms.Label();
			this.textBoxFlightNo = new System.Windows.Forms.TextBox();
			this.buttonFlightNo = new System.Windows.Forms.Button();
			this.buttonAuto = new System.Windows.Forms.Button();
			this.timerPlot = new System.Windows.Forms.Timer(this.components);
			this.buttonPrev = new System.Windows.Forms.Button();
			this.buttonNext = new System.Windows.Forms.Button();
			this.buttonLoad = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonSinCos
			// 
			this.buttonSinCos.BackColor = System.Drawing.SystemColors.Control;
			this.buttonSinCos.Location = new System.Drawing.Point(24, 632);
			this.buttonSinCos.Name = "buttonSinCos";
			this.buttonSinCos.Size = new System.Drawing.Size(96, 24);
			this.buttonSinCos.TabIndex = 1;
			this.buttonSinCos.Text = "Sine-Cosine";
			this.buttonSinCos.Click += new System.EventHandler(this.buttonSinCos_Click);
			this.buttonSinCos.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonSinCos_KeyDown);
			// 
			// PlotControlXY
			// 
			this.PlotControlXY.AbsolutePoint = new System.Drawing.Point(-2147483583, -2147483089);
			this.PlotControlXY.BackColor = System.Drawing.SystemColors.Window;
			this.PlotControlXY.ConnectPointsFlag = false;
			this.PlotControlXY.CurrentIndex = 0;
			this.PlotControlXY.LabelX = "";
			this.PlotControlXY.LabelY = "";
			this.PlotControlXY.LineColor = System.Drawing.Color.Blue;
			this.PlotControlXY.Location = new System.Drawing.Point(-24, 16);
			this.PlotControlXY.Name = "PlotControlXY";
			this.PlotControlXY.NumberOfPoints = 0;
			this.PlotControlXY.Size = new System.Drawing.Size(992, 600);
			this.PlotControlXY.TabIndex = 22;
			this.PlotControlXY.XOrigin = 0F;
			this.PlotControlXY.XTickValue = 1F;
			this.PlotControlXY.XValue = -2.147484E+09F;
			this.PlotControlXY.YOrigin = 0F;
			this.PlotControlXY.YTickValue = 1F;
			this.PlotControlXY.YValue = -2.147484E+09F;
			this.PlotControlXY.KeyDown += new System.Windows.Forms.KeyEventHandler(this.PlotControlXY_KeyDown);
			// 
			// buttonSinVsCos
			// 
			this.buttonSinVsCos.BackColor = System.Drawing.SystemColors.Control;
			this.buttonSinVsCos.Location = new System.Drawing.Point(632, 632);
			this.buttonSinVsCos.Name = "buttonSinVsCos";
			this.buttonSinVsCos.Size = new System.Drawing.Size(96, 24);
			this.buttonSinVsCos.TabIndex = 8;
			this.buttonSinVsCos.Text = "Sine vs. Cosine";
			this.buttonSinVsCos.Click += new System.EventHandler(this.buttonSinVsCos_Click);
			this.buttonSinVsCos.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonSinVsCos_KeyDown);
			// 
			// labelStartX
			// 
			this.labelStartX.Location = new System.Drawing.Point(136, 632);
			this.labelStartX.Name = "labelStartX";
			this.labelStartX.Size = new System.Drawing.Size(96, 32);
			this.labelStartX.TabIndex = 2;
			this.labelStartX.Text = "Start X = -999.99";
			// 
			// buttonStartX
			// 
			this.buttonStartX.BackColor = System.Drawing.SystemColors.Control;
			this.buttonStartX.Location = new System.Drawing.Point(288, 632);
			this.buttonStartX.Name = "buttonStartX";
			this.buttonStartX.TabIndex = 4;
			this.buttonStartX.Text = "Change It";
			this.buttonStartX.Click += new System.EventHandler(this.buttonStartX_Click);
			this.buttonStartX.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonStartX_KeyDown);
			// 
			// textBoxStartX
			// 
			this.textBoxStartX.Location = new System.Drawing.Point(232, 632);
			this.textBoxStartX.Name = "textBoxStartX";
			this.textBoxStartX.Size = new System.Drawing.Size(56, 20);
			this.textBoxStartX.TabIndex = 3;
			this.textBoxStartX.Text = "0";
			this.textBoxStartX.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxStartX_KeyDown);
			this.textBoxStartX.TextChanged += new System.EventHandler(this.textBoxStartX_TextChanged);
			// 
			// labelStopX
			// 
			this.labelStopX.Location = new System.Drawing.Point(376, 632);
			this.labelStopX.Name = "labelStopX";
			this.labelStopX.Size = new System.Drawing.Size(96, 32);
			this.labelStopX.TabIndex = 5;
			this.labelStopX.Text = "Stop X = -999.99";
			// 
			// buttonStopX
			// 
			this.buttonStopX.BackColor = System.Drawing.SystemColors.Control;
			this.buttonStopX.Location = new System.Drawing.Point(528, 632);
			this.buttonStopX.Name = "buttonStopX";
			this.buttonStopX.TabIndex = 7;
			this.buttonStopX.Text = "Change It";
			this.buttonStopX.Click += new System.EventHandler(this.buttonStopX_Click);
			this.buttonStopX.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonStopX_KeyDown);
			// 
			// textBoxStopX
			// 
			this.textBoxStopX.Location = new System.Drawing.Point(472, 632);
			this.textBoxStopX.Name = "textBoxStopX";
			this.textBoxStopX.Size = new System.Drawing.Size(56, 20);
			this.textBoxStopX.TabIndex = 6;
			this.textBoxStopX.Text = "0";
			this.textBoxStopX.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxStopX_KeyDown);
			this.textBoxStopX.TextChanged += new System.EventHandler(this.textBoxStopX_TextChanged);
			// 
			// buttonStartY
			// 
			this.buttonStartY.BackColor = System.Drawing.SystemColors.Control;
			this.buttonStartY.Location = new System.Drawing.Point(288, 664);
			this.buttonStartY.Name = "buttonStartY";
			this.buttonStartY.TabIndex = 15;
			this.buttonStartY.Text = "Change It";
			this.buttonStartY.Click += new System.EventHandler(this.buttonStartY_Click);
			this.buttonStartY.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonStartY_KeyDown);
			// 
			// textBoxStartY
			// 
			this.textBoxStartY.Location = new System.Drawing.Point(232, 664);
			this.textBoxStartY.Name = "textBoxStartY";
			this.textBoxStartY.Size = new System.Drawing.Size(56, 20);
			this.textBoxStartY.TabIndex = 14;
			this.textBoxStartY.Text = "0";
			this.textBoxStartY.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxStartY_KeyDown);
			this.textBoxStartY.TextChanged += new System.EventHandler(this.textBoxStartY_TextChanged);
			// 
			// buttonExit
			// 
			this.buttonExit.BackColor = System.Drawing.SystemColors.Control;
			this.buttonExit.Location = new System.Drawing.Point(912, 632);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.Size = new System.Drawing.Size(48, 24);
			this.buttonExit.TabIndex = 11;
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			this.buttonExit.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonExit_KeyDown);
			// 
			// buttonAbout
			// 
			this.buttonAbout.BackColor = System.Drawing.SystemColors.Control;
			this.buttonAbout.Location = new System.Drawing.Point(864, 632);
			this.buttonAbout.Name = "buttonAbout";
			this.buttonAbout.Size = new System.Drawing.Size(48, 24);
			this.buttonAbout.TabIndex = 10;
			this.buttonAbout.Text = "About";
			this.buttonAbout.Click += new System.EventHandler(this.buttonAbout_Click);
			this.buttonAbout.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonAbout_KeyDown);
			// 
			// buttonPlotKite
			// 
			this.buttonPlotKite.BackColor = System.Drawing.SystemColors.Control;
			this.buttonPlotKite.Location = new System.Drawing.Point(24, 664);
			this.buttonPlotKite.Name = "buttonPlotKite";
			this.buttonPlotKite.Size = new System.Drawing.Size(96, 24);
			this.buttonPlotKite.TabIndex = 12;
			this.buttonPlotKite.Text = "Plot Kite";
			this.buttonPlotKite.Click += new System.EventHandler(this.buttonPlotKite_Click);
			this.buttonPlotKite.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonPlotKite_KeyDown);
			// 
			// labelStartY
			// 
			this.labelStartY.Location = new System.Drawing.Point(136, 664);
			this.labelStartY.Name = "labelStartY";
			this.labelStartY.Size = new System.Drawing.Size(96, 32);
			this.labelStartY.TabIndex = 13;
			this.labelStartY.Text = "Start Y = -999.99";
			// 
			// labelFlightNo
			// 
			this.labelFlightNo.Location = new System.Drawing.Point(376, 664);
			this.labelFlightNo.Name = "labelFlightNo";
			this.labelFlightNo.Size = new System.Drawing.Size(96, 32);
			this.labelFlightNo.TabIndex = 16;
			this.labelFlightNo.Text = "Flight # = 10000";
			// 
			// textBoxFlightNo
			// 
			this.textBoxFlightNo.Location = new System.Drawing.Point(472, 664);
			this.textBoxFlightNo.Name = "textBoxFlightNo";
			this.textBoxFlightNo.Size = new System.Drawing.Size(56, 20);
			this.textBoxFlightNo.TabIndex = 17;
			this.textBoxFlightNo.Text = "0";
			this.textBoxFlightNo.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxFlightNo_KeyDown);
			this.textBoxFlightNo.TextChanged += new System.EventHandler(this.textBoxFlightNo_TextChanged);
			// 
			// buttonFlightNo
			// 
			this.buttonFlightNo.BackColor = System.Drawing.SystemColors.Control;
			this.buttonFlightNo.Location = new System.Drawing.Point(528, 664);
			this.buttonFlightNo.Name = "buttonFlightNo";
			this.buttonFlightNo.TabIndex = 18;
			this.buttonFlightNo.Text = "Change It";
			this.buttonFlightNo.Click += new System.EventHandler(this.buttonFlightNo_Click);
			this.buttonFlightNo.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonFlightNo_KeyDown);
			// 
			// buttonAuto
			// 
			this.buttonAuto.BackColor = System.Drawing.SystemColors.Control;
			this.buttonAuto.Location = new System.Drawing.Point(864, 664);
			this.buttonAuto.Name = "buttonAuto";
			this.buttonAuto.Size = new System.Drawing.Size(96, 23);
			this.buttonAuto.TabIndex = 21;
			this.buttonAuto.Text = "Auto Display";
			this.buttonAuto.Click += new System.EventHandler(this.buttonAuto_Click);
			this.buttonAuto.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonAuto_KeyDown);
			// 
			// timerPlot
			// 
			this.timerPlot.Enabled = true;
			this.timerPlot.Interval = 500;
			this.timerPlot.Tick += new System.EventHandler(this.timerPlot_Tick);
			// 
			// buttonPrev
			// 
			this.buttonPrev.BackColor = System.Drawing.SystemColors.Control;
			this.buttonPrev.Location = new System.Drawing.Point(632, 664);
			this.buttonPrev.Name = "buttonPrev";
			this.buttonPrev.Size = new System.Drawing.Size(96, 23);
			this.buttonPrev.TabIndex = 19;
			this.buttonPrev.Text = "Prev. Flight";
			this.buttonPrev.Click += new System.EventHandler(this.buttonPrev_Click);
			this.buttonPrev.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonPrev_KeyDown);
			// 
			// buttonNext
			// 
			this.buttonNext.BackColor = System.Drawing.SystemColors.Control;
			this.buttonNext.Location = new System.Drawing.Point(744, 664);
			this.buttonNext.Name = "buttonNext";
			this.buttonNext.Size = new System.Drawing.Size(96, 23);
			this.buttonNext.TabIndex = 20;
			this.buttonNext.Text = "Next Flight";
			this.buttonNext.Click += new System.EventHandler(this.buttonNext_Click);
			this.buttonNext.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonNext_KeyDown);
			// 
			// buttonLoad
			// 
			this.buttonLoad.BackColor = System.Drawing.SystemColors.Control;
			this.buttonLoad.Location = new System.Drawing.Point(744, 632);
			this.buttonLoad.Name = "buttonLoad";
			this.buttonLoad.Size = new System.Drawing.Size(96, 23);
			this.buttonLoad.TabIndex = 9;
			this.buttonLoad.Text = "Load Data";
			this.buttonLoad.Click += new System.EventHandler(this.buttonLoad_Click);
			this.buttonLoad.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonLoad_KeyDown);
			// 
			// PlotForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(992, 694);
			this.Controls.Add(this.buttonLoad);
			this.Controls.Add(this.buttonNext);
			this.Controls.Add(this.buttonPrev);
			this.Controls.Add(this.buttonAuto);
			this.Controls.Add(this.buttonFlightNo);
			this.Controls.Add(this.textBoxFlightNo);
			this.Controls.Add(this.textBoxStartY);
			this.Controls.Add(this.textBoxStopX);
			this.Controls.Add(this.textBoxStartX);
			this.Controls.Add(this.labelFlightNo);
			this.Controls.Add(this.labelStartY);
			this.Controls.Add(this.buttonStartY);
			this.Controls.Add(this.buttonPlotKite);
			this.Controls.Add(this.buttonAbout);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.labelStopX);
			this.Controls.Add(this.buttonStopX);
			this.Controls.Add(this.labelStartX);
			this.Controls.Add(this.buttonStartX);
			this.Controls.Add(this.buttonSinVsCos);
			this.Controls.Add(this.PlotControlXY);
			this.Controls.Add(this.buttonSinCos);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "PlotForm";
			this.Text = "<App.Title> - Run";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public void Plot() 
		{
			screen = Screen.PrimaryScreen;
			// gets the screen size but not used
			Size size = new System.Drawing.Size(screen.Bounds.Width, screen.Bounds.Height);
			buttonAuto_Click();
			buttonExit.Focus(); // a new plot form just came up
		}

		private void buttonSinCos_Click(object sender, System.EventArgs e)
		{
			if (startX >= stopX) return;
			if ((stopX - startX) > 10000)
			{
				startX = 0;
				stopX = 660;
				DisplayStartX();
				DisplayStopX();
			}
			PlotControlXY.Reset();
			PlotControlXY.NumberOfPens = 3;
			PlotControlXY.XTickValue = (float)Math.Ceiling(((stopX - startX)* PlotControl.kScreenScale) / 
				PlotControl.kPixelsForX);
			PlotControlXY.YTickValue = 0.1f;
			PlotControlXY.XOrigin = startX;
			PlotControlXY.YOrigin = -1f;
			PlotControlXY.LabelX = "Angle in Degrees (" + PlotControlXY.XTickValue + " Degrees per tick)";
			PlotControlXY.LabelY = "Amplitude";
			PlotControlXY.AddPen(0, Color.Red, 2f);
			PlotControlXY.m_bConnectPoints = true;
			float dX = 0.75f * PlotControlXY.XTickValue / PlotControl.kScreenScale; // computes y at each x 3/4 pixel
			for (float x = startX; x < stopX; x += dX)
			{
				PlotControlXY.AddPoint(x, (float)Math.Sin((double)(x / dPR)));
			}
			PlotControlXY.AddPoint(stopX, (float)Math.Sin((double)(stopX / dPR)));
			PlotControlXY.AddPen(1, Color.Green, 2f);
			for (float x = startX; x < stopX; x += dX)
			{
				PlotControlXY.AddPoint(x, (float)Math.Cos((double)(x / dPR)));
			}
			PlotControlXY.AddPoint(stopX, (float)Math.Cos((double)(stopX / dPR)));
			PlotControlXY.AddPen(2, Color.Blue, 1f);
			PlotControlXY.AddPoint(startX, 0f);
			PlotControlXY.AddPoint(stopX, 0f);
			PlotControlXY.Invalidate();
		}

		private void buttonSinVsCos_Click(object sender, System.EventArgs e)
		{
			PlotControlXY.Reset();
			PlotControlXY.XTickValue = 0.1f;
			PlotControlXY.YTickValue = 0.1f;
			PlotControlXY.XOrigin = -1.5f;
			PlotControlXY.YOrigin = -1f;
			PlotControlXY.LabelX = "Sine of Angle";
			PlotControlXY.LabelY = "Cosine of Angle";
			PlotControlXY.NumberOfPens = 1;
			PlotControlXY.AddPen(0, Color.Green, 2f);
			PlotControlXY.m_bConnectPoints = false;
			for (float i = 0f; i < pi2; i += pi2/500f)
			{
				PlotControlXY.AddPoint((float)Math.Sin((double)i), (float)Math.Cos((double)i));
			}
			PlotControlXY.Invalidate();
		}

		private void textBoxStartX_TextChanged(object sender, System.EventArgs e)
			// process input of StartX
		{
			textBoxStartX.Text = textBoxStartX.Text.TrimStart(' ');			// remove leading spaces
			if (textBoxStartX.Text == "")
			{
				buttonStartX.Enabled = true;
				return;
			}
			string sNum = textBoxStartX.Text;
			buttonStartX.Enabled = IsFloat(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxStartX.Text = textBoxStartX.Text.Trim(' ');			// remove trailing spaces
					textBoxStartX.SelectionStart = textBoxStartX.Text.Length;	// move to right end of input
					if (buttonStartX.Enabled) buttonStartX_Click();				// accept the input
				}
			}
		}

		private void textBoxStartX_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in StartX box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonStartX.Enabled) buttonStartX_Click();
			}
			if (e.KeyCode == Keys.Escape)
			{
				Dispose(true);
			}
		}

		private void buttonStartX_Click(object sender, System.EventArgs e)
		{
			buttonStartX_Click();
		}

		private void buttonStartX_Click()
		{
			if (textBoxStartX.Text != "")				// if "", set to current
				startX = (float)Convert.ToDouble(textBoxStartX.Text);
			textBoxStartX.Text = startX.ToString();
			DisplayStartX();
			textBoxStartX.Focus();
			textBoxStartX.SelectionStart = textBoxStartX.Text.Length;		
		}

		private void DisplayStartX() // display StartX
		{
			labelStartX.Text = "Start X = " + startX;
		}

		private void textBoxStartY_TextChanged(object sender, System.EventArgs e)
			// process input of StartY
		{
			textBoxStartY.Text = textBoxStartY.Text.TrimStart(' ');			// remove leading spaces
			if (textBoxStartY.Text == "")
			{
				buttonStartY.Enabled = true;
				return;
			}
			string sNum = textBoxStartY.Text;
			buttonStartY.Enabled = IsFloat(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxStartY.Text = textBoxStartY.Text.Trim(' ');			// remove trailing spaces
					textBoxStartY.SelectionStart = textBoxStartY.Text.Length;	// move to right end of input
					if (buttonStartY.Enabled) buttonStartY_Click();				// accept the input
				}
			}
		}

		private void textBoxStartY_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in StartY box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonStartY.Enabled) buttonStartY_Click();
			}
			if (e.KeyCode == Keys.Escape)
			{
				Dispose(true);
			}
		}

		private void buttonStartY_Click(object sender, System.EventArgs e)
		{
			buttonStartY_Click();
		}

		private void buttonStartY_Click()
		{
			if (textBoxStartY.Text != "")				// if "", set to current
				startY = (float)Convert.ToDouble(textBoxStartY.Text);
			textBoxStartY.Text = startY.ToString();
			DisplayStartY();
			textBoxStartY.Focus();
			textBoxStartY.SelectionStart = textBoxStartY.Text.Length;		
		}

		private void DisplayStartY() // display StartY
		{
			labelStartY.Text = "Start Y = " + startY;
		}

		private void textBoxStopX_TextChanged(object sender, System.EventArgs e)
		// process input of StopX
		{
			textBoxStopX.Text = textBoxStopX.Text.TrimStart(' ');		// remove leading spaces
			if (textBoxStopX.Text == "")
			{
				buttonStopX.Enabled = true;
				return;
			}
			string sNum = textBoxStopX.Text;
			buttonStopX.Enabled = IsFloat(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxStopX.Text = textBoxStopX.Text.Trim(' ');			// remove trailing spaces
					textBoxStopX.SelectionStart = textBoxStopX.Text.Length;		// move to right end of input
					if (buttonStopX.Enabled) buttonStopX_Click();				// accept the input
				}
			}
		}

		private void textBoxStopX_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in StopX box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonStopX.Enabled) buttonStopX_Click();
			}
			if (e.KeyCode == Keys.Escape)
			{
				Dispose(true);
			}
		}

		private void buttonStopX_Click(object sender, System.EventArgs e)
		{
			buttonStopX_Click();
		}

		private void buttonStopX_Click()
		{
			if (textBoxStopX.Text != "")			// if "", set to current
				stopX = (float)Convert.ToDouble(textBoxStopX.Text);
			textBoxStopX.Text = stopX.ToString();
			DisplayStopX();
			textBoxStopX.Focus();
			textBoxStopX.SelectionStart = textBoxStopX.Text.Length;		
		}

		private void DisplayStopX() // display StopX
		{
			labelStopX.Text = "Stop X = " + stopX;
		}

		public static bool IsFloat(string st) // is input string a good double?
		{
			double dFloat;
			try
			{
				dFloat = (float)System.Double.Parse(st);
				if (-large <= dFloat && dFloat <= large)
					return true;
				else
					return false;
			}
			catch // (FormatException ex)
			{
				return false;
			}
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		// exit the program
		{
			Common.abortCalc = true;
			Dispose(true);
		}

		private void buttonAbout_Click(object sender, System.EventArgs e)
			// bring up information about this program
		{
			try
			{
				AboutForm aboutForm = new AboutForm();
				aboutForm.ShowDialog();
				if (aboutForm.DialogResult == DialogResult.Cancel)
				{
					aboutForm.Dispose();
				}
			}
			catch (Exception ex)
			{
				System.Console.WriteLine(ex.Message.ToString());
			}
		}

		private void buttonPlotKite_Click(object sender, System.EventArgs e)
		{
			buttonPlotKite_Click();
		}

		private void buttonPlotKite_Click()
		{
			Common.abortCalc = false;
			maxX = double.MinValue;
			minY = double.MaxValue;
			if (startX >= stopX) return;
			PlotControlXY.Reset();
			PlotControlXY.NumberOfPens = 3;
			PlotControlXY.XTickValue = (float)Math.Ceiling(((stopX - startX)* PlotControl.kScreenScale) / 
				PlotControl.kPixelsForX);
			PlotControlXY.XTickValue = 100f * (float)Math.Ceiling(PlotControlXY.XTickValue / 100.0);
			PlotControlXY.YTickValue = PlotControlXY.XTickValue;
			PlotControlXY.XOrigin = startX;
			PlotControlXY.YOrigin = startY;
			PlotControlXY.LabelX = "X - Down Range in feet (" + PlotControlXY.XTickValue + 
				" Feet per tick) - Flight Number " + flightNo;
			PlotControlXY.LabelY = "Y - Altitude in feet";
			PlotControlXY.AddPen(0, Color.Green, 2f);
			PlotControlXY.m_bConnectPoints = true;
			float dX = 0.75f * PlotControlXY.XTickValue / PlotControl.kScreenScale; // computes y at each x 3/4 pixel
			FlyAKite.GetParam();
			FlyAKite.GetCase(flightNo);
			if (FlyAKite.factorC == 0.0)
			{
				FlyAKite.Param.start = flightNo;
				FlyAKite.Param.stop = flightNo;
				FlyAKite.CompFactor();
				FlyAKite.GetCase(flightNo);
			}
			FlyAKite.ResetToFlyer();
			double s = 0;
			double dS = PlotControlXY.XTickValue / PlotControl.kScreenScale; // computes at each s pixel
			PlotControlXY.AddPoint(0.0f, 0.0f);
			while (s < FlyAKite.lengthD && !Common.abortCalc)
			{
				double length = s + dS;
				if (length > FlyAKite.lengthD) length = FlyAKite.lengthD;
				FlyAKite.AIRK(ref s, length, dS);
				FlyAKite.RHSF();
				PlotControlXY.AddPoint((float)FlyAKite.Vector.x, (float)FlyAKite.Vector.y);
				if (FlyAKite.Vector.x > maxX) maxX = FlyAKite.Vector.x;
				if (FlyAKite.Vector.y < minY) minY = FlyAKite.Vector.y;
			}
			PlotControlXY.AddPen(1, Color.Red, 2f);
			DrawMark((float)FlyAKite.Vector.x, (float)FlyAKite.Vector.y,
					(float)FlyAKite.Vector.tX, (float)FlyAKite.Vector.tY);
			int points = 0;
			int pointsMax = 2000;
			while (FlyAKite.Vector.x > startX && points < pointsMax && !Common.abortCalc)
			{
				points++;
				double length = s + dS;
				FlyAKite.AIRK(ref s, length, dS);
				FlyAKite.RHSF();
				PlotControlXY.AddPoint((float)FlyAKite.Vector.x, (float)FlyAKite.Vector.y);
				if (FlyAKite.Vector.x > maxX) maxX = FlyAKite.Vector.x;
				if (FlyAKite.Vector.y < minY) minY = FlyAKite.Vector.y;
			}
			PlotControlXY.AddPen(2, Color.Red, 2f);
			FlyAKite.ResetToFlyer();
			s = 0;
			DrawMark(0.0f, 0.0f, (float)FlyAKite.Vector.tX, (float)FlyAKite.Vector.tY);
			points = 0;
			while (FlyAKite.Vector.x > startX && points < pointsMax && !Common.abortCalc)
			{
				points++;
				double length = s - dS;
				FlyAKite.AIRK(ref s, length, dS);
				FlyAKite.RHSF();
				PlotControlXY.AddPoint((float)FlyAKite.Vector.x, (float)FlyAKite.Vector.y);
				if (FlyAKite.Vector.x > maxX) maxX = FlyAKite.Vector.x;
				if (FlyAKite.Vector.y < minY) minY = FlyAKite.Vector.y;
			}
			Common.abortCalc = false;
			PlotControlXY.Invalidate();
		} // buttonPlotKite_Click

		private void DrawMark(float x, float y, float tX, float tY)
		{
			float fudge = 0.75f; // this prevents overshoot at end point of mark
			float eX = 0.3f * PlotControlXY.XTickValue * tY / (float)FlyAKite.tensionC;
			float eY = 0.3f * PlotControlXY.XTickValue * tX / (float)FlyAKite.tensionC;
			PlotControlXY.AddPoint(x, y);
			PlotControlXY.AddPoint(x - fudge * eX, y + fudge * eY);
			PlotControlXY.AddPoint(x - eX, y + eY);
			PlotControlXY.AddPoint(x - fudge * eX, y + fudge * eY);
			PlotControlXY.AddPoint(x + fudge * eX, y - fudge * eY);
			PlotControlXY.AddPoint(x + eX, y - eY);
			PlotControlXY.AddPoint(x + fudge * eX, y - fudge * eY);
			PlotControlXY.AddPoint(x, y);
		}

		private void textBoxFlightNo_TextChanged(object sender, System.EventArgs e)
			// process input of FlightNo
		{
			textBoxFlightNo.Text = textBoxFlightNo.Text.TrimStart(' ');		// remove leading spaces
			if (textBoxFlightNo.Text == "")
			{
				buttonFlightNo.Enabled = true;
				return;
			}
			string sNum = textBoxFlightNo.Text;
			if (Global.IsInt32(sNum))
			{
				int iNum = Convert.ToInt32(sNum);
				buttonFlightNo.Enabled = ((1 <= iNum) &  (iNum <= FlyAKite.Param.lines)); // and iNum ok
			}
			else
			{
				buttonFlightNo.Enabled = false;
			}
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ') // if space at right end of field
				{
					textBoxFlightNo.Text = textBoxFlightNo.Text.Trim(' ');			// remove trailing spaces
					textBoxFlightNo.SelectionStart = textBoxFlightNo.Text.Length;	// move to right end of input
					if (buttonFlightNo.Enabled) buttonFlightNo_Click();				// accept the input
				}
			}
		} // textBoxFlightNo_TextChanged

		private void textBoxFlightNo_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// process keys when in FlightNo box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonFlightNo.Enabled) buttonFlightNo_Click();
			}
			if (e.KeyCode == Keys.Escape)
			{
				Dispose(true);
			}
		}
		
		private void buttonFlightNo_Click(object sender, System.EventArgs e)
		{
			
			if (textBoxFlightNo.Text != "" && Convert.ToInt32(textBoxFlightNo.Text) > FlyAKite.Param.lines)
				textBoxFlightNo.Text = FlyAKite.Param.lines.ToString();
			buttonFlightNo_Click();		
		}

		private void buttonFlightNo_Click()
		{
			if (textBoxFlightNo.Text != "")			// if "", set to current
				flightNo = Convert.ToInt32(textBoxFlightNo.Text);
			textBoxFlightNo.Text = flightNo.ToString();
			DisplayFlightNo();
			textBoxFlightNo.Focus();
			textBoxFlightNo.SelectionStart = textBoxFlightNo.Text.Length;		
		}

		private void DisplayFlightNo()
		{
			labelFlightNo.Text = "Flight # = " + flightNo + " of " + FlyAKite.Param.lines;
		}

		private void buttonAuto_Click(object sender, System.EventArgs e)
		{
			buttonAuto_Click();
			buttonAuto.Focus();
		}

		private void buttonAuto_Click()
		{
			buttonAuto_Click2();
		}

		private void buttonAuto_Click2()
		{
			buttonAuto_Click1();
			buttonAuto_Click1();
		}

		private void buttonAuto_Click1()
		{
			stopX = 1000f * (float)Math.Ceiling(maxX / 1000.0);
			startY = 1000f * (float)Math.Floor(minY / 1000.0);
			if (stopX < float.MinValue) stopX = 1000;
			if (startY > float.MaxValue) startY = -1000;
			textBoxStartY.Text = startY.ToString();
			buttonStartY_Click();
			textBoxStopX.Text = stopX.ToString();
			buttonStopX_Click();
			buttonPlotKite_Click();
		}

		private void timerPlot_Tick(object sender, System.EventArgs e)
			// update display of changeable items
		{
			if (!Global.runFormUp)
			{
				Dispose(true);
				return;
			}
			textBoxFlightNo_TextChanged(sender, e);
			if (flightNo > FlyAKite.Param.lines) flightNo = FlyAKite.Param.lines;
			DisplayFlightNo();
		}

		private void buttonExit_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void TestExit(System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape)
			{
				Dispose(true);
			}
		}

		private void buttonPrev_Click(object sender, System.EventArgs e)
		{
			flightNo--;
			if (flightNo < 1) flightNo = FlyAKite.Param.lines;
			textBoxFlightNo.Text = flightNo.ToString();
			DisplayFlightNo();
			buttonAuto_Click2();
			buttonPrev.Focus();
		}

		private void buttonNext_Click(object sender, System.EventArgs e)
		{
			flightNo++;
			if (flightNo > FlyAKite.Param.lines) flightNo = 1;
			textBoxFlightNo.Text = flightNo.ToString();
			DisplayFlightNo();
			buttonAuto_Click2();
			buttonNext.Focus();
		}

		private void buttonLoad_Click(object sender, System.EventArgs e)
		{
			RunForm.buttonLoad_Click();
			buttonLoad.Focus();
		}

		private void buttonSinCos_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonStartX_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonStopX_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonSinVsCos_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonLoad_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonAbout_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonPlotKite_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonStartY_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonFlightNo_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonPrev_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonNext_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonAuto_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}

		private void PlotControlXY_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			TestExit(e);
		}
	}
}
