using System;
using System.IO;
using System.Windows.Forms; // for Application

namespace MyNamespace
{
	/// <summary>
	///		Run form for FlyAKite program
	///		Developed in TURBO Pascal 5.5 and 6.0, converted to Visual C# .Net
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class RunForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.RichTextBox richTextOut;
		private System.Windows.Forms.MainMenu mainMenuRun;
		private System.Windows.Forms.MenuItem menuItemFile;
		private System.Windows.Forms.MenuItem menuItemExit;
		private System.Windows.Forms.MenuItem menuItemHelp;
		private System.Windows.Forms.MenuItem menuItemHelpForm;
		private System.Windows.Forms.MenuItem menuItemAbout;
		private System.Windows.Forms.Button buttonClearLogFile;
		private System.Windows.Forms.Button buttonLog;
		private System.Windows.Forms.Button buttonClearOutput;
		private System.Windows.Forms.Timer timerRun;
		private System.Windows.Forms.Button buttonConfiguration;
		public System.Windows.Forms.Button buttonPlot;
		private System.Windows.Forms.Button buttonQuit;
		private System.Windows.Forms.Label labelCtrlF9;
		private System.Windows.Forms.Label labelF9;
		private System.Windows.Forms.Label labelF6;
		private System.Windows.Forms.Label labelF11;
		private System.Windows.Forms.Label labelF8;
		private System.Windows.Forms.Label labelF12;
		private System.Windows.Forms.Label labelF2;
		private System.Windows.Forms.Button buttonCalculate;
		private System.Windows.Forms.Button buttonLoad;
		private System.Windows.Forms.Label labelF7;
		private System.Windows.Forms.Button buttonAbortCalc;
		private System.Windows.Forms.Label labelEsc;
		private System.Windows.Forms.Button buttonShowData;
		private System.Windows.Forms.Label labelF5;
		private System.ComponentModel.IContainer components;

		public RunForm()
		{
			InitializeComponent();

			Global.runTextOut = richTextOut;
			Global.runTextOut.Clear();
			Global.objRunForm = this;
			this.Width = runWidth;			// Resize the form
			this.Height = runHeight;
			this.CenterToScreen();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(RunForm));
			this.richTextOut = new System.Windows.Forms.RichTextBox();
			this.mainMenuRun = new System.Windows.Forms.MainMenu();
			this.menuItemFile = new System.Windows.Forms.MenuItem();
			this.menuItemExit = new System.Windows.Forms.MenuItem();
			this.menuItemHelp = new System.Windows.Forms.MenuItem();
			this.menuItemHelpForm = new System.Windows.Forms.MenuItem();
			this.menuItemAbout = new System.Windows.Forms.MenuItem();
			this.buttonClearLogFile = new System.Windows.Forms.Button();
			this.buttonLog = new System.Windows.Forms.Button();
			this.buttonClearOutput = new System.Windows.Forms.Button();
			this.buttonConfiguration = new System.Windows.Forms.Button();
			this.buttonQuit = new System.Windows.Forms.Button();
			this.timerRun = new System.Windows.Forms.Timer(this.components);
			this.labelF9 = new System.Windows.Forms.Label();
			this.labelF6 = new System.Windows.Forms.Label();
			this.labelF11 = new System.Windows.Forms.Label();
			this.labelCtrlF9 = new System.Windows.Forms.Label();
			this.labelF8 = new System.Windows.Forms.Label();
			this.labelF12 = new System.Windows.Forms.Label();
			this.labelF2 = new System.Windows.Forms.Label();
			this.buttonPlot = new System.Windows.Forms.Button();
			this.buttonCalculate = new System.Windows.Forms.Button();
			this.buttonLoad = new System.Windows.Forms.Button();
			this.labelF7 = new System.Windows.Forms.Label();
			this.buttonAbortCalc = new System.Windows.Forms.Button();
			this.labelEsc = new System.Windows.Forms.Label();
			this.buttonShowData = new System.Windows.Forms.Button();
			this.labelF5 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// richTextOut
			// 
			this.richTextOut.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.richTextOut.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.richTextOut.Location = new System.Drawing.Point(0, 88);
			this.richTextOut.Name = "richTextOut";
			this.richTextOut.ReadOnly = true;
			this.richTextOut.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.ForcedVertical;
			this.richTextOut.Size = new System.Drawing.Size(664, 440);
			this.richTextOut.TabIndex = 13;
			this.richTextOut.Text = "";
			this.richTextOut.KeyDown += new System.Windows.Forms.KeyEventHandler(this.richTextOut_KeyDown);
			// 
			// mainMenuRun
			// 
			this.mainMenuRun.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						this.menuItemFile,
																						this.menuItemHelp});
			// 
			// menuItemFile
			// 
			this.menuItemFile.Index = 0;
			this.menuItemFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItemExit});
			this.menuItemFile.Text = " &File ";
			// 
			// menuItemExit
			// 
			this.menuItemExit.Index = 0;
			this.menuItemExit.Text = "E&xit";
			this.menuItemExit.Click += new System.EventHandler(this.menuItemExit_Click);
			// 
			// menuItemHelp
			// 
			this.menuItemHelp.Index = 1;
			this.menuItemHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItemHelpForm,
																						 this.menuItemAbout});
			this.menuItemHelp.Text = " &Help F1 ";
			// 
			// menuItemHelpForm
			// 
			this.menuItemHelpForm.Index = 0;
			this.menuItemHelpForm.Text = "&Help Form        F1";
			this.menuItemHelpForm.Click += new System.EventHandler(this.menuItemHelpForm_Click);
			// 
			// menuItemAbout
			// 
			this.menuItemAbout.Index = 1;
			this.menuItemAbout.Text = "&About...";
			this.menuItemAbout.Click += new System.EventHandler(this.menuItemAbout_Click);
			// 
			// buttonClearLogFile
			// 
			this.buttonClearLogFile.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.buttonClearLogFile.Location = new System.Drawing.Point(16, 8);
			this.buttonClearLogFile.Name = "buttonClearLogFile";
			this.buttonClearLogFile.Size = new System.Drawing.Size(88, 23);
			this.buttonClearLogFile.TabIndex = 1;
			this.buttonClearLogFile.Text = "Clear Log File";
			this.buttonClearLogFile.Click += new System.EventHandler(this.buttonClearLogFile_Click);
			this.buttonClearLogFile.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonClearLogFile_KeyDown);
			// 
			// buttonLog
			// 
			this.buttonLog.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.buttonLog.Font = new System.Drawing.Font("Tahoma", 7.75F, System.Drawing.FontStyle.Bold);
			this.buttonLog.Location = new System.Drawing.Point(120, 8);
			this.buttonLog.Name = "buttonLog";
			this.buttonLog.Size = new System.Drawing.Size(88, 23);
			this.buttonLog.TabIndex = 2;
			this.buttonLog.Text = "Logging Is Off";
			this.buttonLog.Click += new System.EventHandler(this.buttonLog_Click);
			this.buttonLog.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonLog_KeyDown);
			// 
			// buttonClearOutput
			// 
			this.buttonClearOutput.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonClearOutput.Location = new System.Drawing.Point(432, 8);
			this.buttonClearOutput.Name = "buttonClearOutput";
			this.buttonClearOutput.Size = new System.Drawing.Size(88, 23);
			this.buttonClearOutput.TabIndex = 4;
			this.buttonClearOutput.Text = "Clear Output";
			this.buttonClearOutput.Click += new System.EventHandler(this.buttonClearOutput_Click);
			this.buttonClearOutput.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonClearOutput_KeyDown);
			// 
			// buttonConfiguration
			// 
			this.buttonConfiguration.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.buttonConfiguration.Location = new System.Drawing.Point(224, 48);
			this.buttonConfiguration.Name = "buttonConfiguration";
			this.buttonConfiguration.Size = new System.Drawing.Size(88, 23);
			this.buttonConfiguration.TabIndex = 6;
			this.buttonConfiguration.Text = "Config./Edit";
			this.buttonConfiguration.Click += new System.EventHandler(this.buttonConfiguration_Click);
			this.buttonConfiguration.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonConfiguration_KeyDown);
			// 
			// buttonQuit
			// 
			this.buttonQuit.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonQuit.Location = new System.Drawing.Point(600, 48);
			this.buttonQuit.Name = "buttonQuit";
			this.buttonQuit.Size = new System.Drawing.Size(48, 23);
			this.buttonQuit.TabIndex = 10;
			this.buttonQuit.Text = "Quit";
			this.buttonQuit.Click += new System.EventHandler(this.buttonQuit_Click);
			this.buttonQuit.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonQuit_KeyDown);
			// 
			// timerRun
			// 
			this.timerRun.Enabled = true;
			this.timerRun.Interval = 1000;
			this.timerRun.Tick += new System.EventHandler(this.timerRun_Tick);
			// 
			// labelF9
			// 
			this.labelF9.Font = new System.Drawing.Font("Tahoma", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelF9.Location = new System.Drawing.Point(152, 32);
			this.labelF9.Name = "labelF9";
			this.labelF9.Size = new System.Drawing.Size(24, 16);
			this.labelF9.TabIndex = 17;
			this.labelF9.Text = "F9";
			// 
			// labelF6
			// 
			this.labelF6.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelF6.Location = new System.Drawing.Point(256, 72);
			this.labelF6.Name = "labelF6";
			this.labelF6.Size = new System.Drawing.Size(24, 16);
			this.labelF6.TabIndex = 20;
			this.labelF6.Text = "F6";
			// 
			// labelF11
			// 
			this.labelF11.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelF11.Location = new System.Drawing.Point(464, 32);
			this.labelF11.Name = "labelF11";
			this.labelF11.Size = new System.Drawing.Size(24, 16);
			this.labelF11.TabIndex = 25;
			this.labelF11.Text = "F11";
			// 
			// labelCtrlF9
			// 
			this.labelCtrlF9.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelCtrlF9.Location = new System.Drawing.Point(40, 32);
			this.labelCtrlF9.Name = "labelCtrlF9";
			this.labelCtrlF9.Size = new System.Drawing.Size(40, 16);
			this.labelCtrlF9.TabIndex = 26;
			this.labelCtrlF9.Text = "Ctrl+F9";
			// 
			// labelF8
			// 
			this.labelF8.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelF8.Location = new System.Drawing.Point(464, 72);
			this.labelF8.Name = "labelF8";
			this.labelF8.Size = new System.Drawing.Size(24, 16);
			this.labelF8.TabIndex = 27;
			this.labelF8.Text = "F8";
			// 
			// labelF12
			// 
			this.labelF12.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelF12.Location = new System.Drawing.Point(552, 72);
			this.labelF12.Name = "labelF12";
			this.labelF12.Size = new System.Drawing.Size(24, 16);
			this.labelF12.TabIndex = 30;
			this.labelF12.Text = "F12";
			// 
			// labelF2
			// 
			this.labelF2.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelF2.Location = new System.Drawing.Point(616, 72);
			this.labelF2.Name = "labelF2";
			this.labelF2.Size = new System.Drawing.Size(24, 16);
			this.labelF2.TabIndex = 28;
			this.labelF2.Text = "F2";
			// 
			// buttonPlot
			// 
			this.buttonPlot.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonPlot.Location = new System.Drawing.Point(536, 48);
			this.buttonPlot.Name = "buttonPlot";
			this.buttonPlot.Size = new System.Drawing.Size(48, 23);
			this.buttonPlot.TabIndex = 9;
			this.buttonPlot.Text = "Plot";
			this.buttonPlot.Click += new System.EventHandler(this.buttonPlot_Click);
			this.buttonPlot.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonPlot_KeyDown);
			// 
			// buttonCalculate
			// 
			this.buttonCalculate.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonCalculate.Location = new System.Drawing.Point(432, 48);
			this.buttonCalculate.Name = "buttonCalculate";
			this.buttonCalculate.Size = new System.Drawing.Size(88, 23);
			this.buttonCalculate.TabIndex = 8;
			this.buttonCalculate.Text = "Calculate";
			this.buttonCalculate.Click += new System.EventHandler(this.buttonCalculate_Click);
			this.buttonCalculate.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonCalculate_KeyDown);
			// 
			// buttonLoad
			// 
			this.buttonLoad.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonLoad.Location = new System.Drawing.Point(328, 48);
			this.buttonLoad.Name = "buttonLoad";
			this.buttonLoad.Size = new System.Drawing.Size(88, 23);
			this.buttonLoad.TabIndex = 7;
			this.buttonLoad.Text = "Load Data";
			this.buttonLoad.Click += new System.EventHandler(this.buttonLoad_Click);
			this.buttonLoad.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonLoad_KeyDown);
			// 
			// labelF7
			// 
			this.labelF7.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelF7.Location = new System.Drawing.Point(360, 72);
			this.labelF7.Name = "labelF7";
			this.labelF7.Size = new System.Drawing.Size(24, 16);
			this.labelF7.TabIndex = 32;
			this.labelF7.Text = "F7";
			// 
			// buttonAbortCalc
			// 
			this.buttonAbortCalc.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.buttonAbortCalc.Location = new System.Drawing.Point(16, 48);
			this.buttonAbortCalc.Name = "buttonAbortCalc";
			this.buttonAbortCalc.Size = new System.Drawing.Size(88, 23);
			this.buttonAbortCalc.TabIndex = 5;
			this.buttonAbortCalc.Text = "Abort Calc.";
			this.buttonAbortCalc.Click += new System.EventHandler(this.buttonAbortCalc_Click);
			this.buttonAbortCalc.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonAbortCalc_KeyDown);
			// 
			// labelEsc
			// 
			this.labelEsc.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelEsc.Location = new System.Drawing.Point(48, 72);
			this.labelEsc.Name = "labelEsc";
			this.labelEsc.Size = new System.Drawing.Size(24, 16);
			this.labelEsc.TabIndex = 34;
			this.labelEsc.Text = "Esc";
			// 
			// buttonShowData
			// 
			this.buttonShowData.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonShowData.Location = new System.Drawing.Point(328, 8);
			this.buttonShowData.Name = "buttonShowData";
			this.buttonShowData.Size = new System.Drawing.Size(88, 23);
			this.buttonShowData.TabIndex = 3;
			this.buttonShowData.Text = "Show Data";
			this.buttonShowData.Click += new System.EventHandler(this.buttonShowData_Click);
			this.buttonShowData.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonShowData_KeyDown);
			// 
			// labelF5
			// 
			this.labelF5.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelF5.Location = new System.Drawing.Point(360, 32);
			this.labelF5.Name = "labelF5";
			this.labelF5.Size = new System.Drawing.Size(24, 16);
			this.labelF5.TabIndex = 36;
			this.labelF5.Text = "F5";
			// 
			// RunForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(666, 529);
			this.Controls.Add(this.labelF5);
			this.Controls.Add(this.buttonShowData);
			this.Controls.Add(this.labelEsc);
			this.Controls.Add(this.buttonAbortCalc);
			this.Controls.Add(this.labelF7);
			this.Controls.Add(this.buttonLoad);
			this.Controls.Add(this.labelF12);
			this.Controls.Add(this.buttonPlot);
			this.Controls.Add(this.labelF2);
			this.Controls.Add(this.labelF8);
			this.Controls.Add(this.labelCtrlF9);
			this.Controls.Add(this.labelF11);
			this.Controls.Add(this.labelF6);
			this.Controls.Add(this.labelF9);
			this.Controls.Add(this.buttonQuit);
			this.Controls.Add(this.buttonCalculate);
			this.Controls.Add(this.buttonConfiguration);
			this.Controls.Add(this.buttonClearOutput);
			this.Controls.Add(this.buttonLog);
			this.Controls.Add(this.buttonClearLogFile);
			this.Controls.Add(this.richTextOut);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenuRun;
			this.Name = "RunForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "<App.Title> - Run";
			this.Resize += new System.EventHandler(this.RunForm_Resize);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.memberFormClosing);
			this.ResumeLayout(false);

		}
		#endregion

		public void Run(int iMaxFlights, StartupForm callerForm)
		// -------- Begin Main program Run for input and output to control calculations
		{
			if (Global.runFormUp) { Dispose(true); return; }
			tQuitFlag = true;
			Global.runFormUp = true;
			Global.programURL = "http://www.geocities.com/hjsmithh/FlyAKite/";
			this.Show();
			this.Text = Global.title + " - Run";
			objStartupForm = callerForm;
			new Common();	// initialize class Common
			new FlyAKite(iMaxFlights);	// initialize class FlyAKite
			if (Common.homeDir == null) Common.homeDir = Environment.CurrentDirectory.ToString();
			if (Common.selectPath == null) Common.selectPath = Common.homeDir;
			if (Common.selectFile == null) Common.selectFile = "";
			if (Common.selectFilter == 0) Common.selectFilter = 1;
			Common.outS = Global.runTextOut;
			Common.runCmdLog = buttonLog;
			Global.runTextOut.Clear();
			ClearOutput();
			Common.running = false;
			Common.DoubleSpace();
			buttonPlot.Focus();
		} // Run

		private void buttonCalculate_Click(object sender, System.EventArgs e)
		{
			buttonCalculate_Click();
		}

		public void buttonCalculate_Click()	// calculate
		{
			Calculate();
		}

		public static void Calculate() // calculate
		{
			FlyAKite.CompFactor();
			FocusBothUs();
		}

		public static void FocusBothUs() // focus on Run output text boxes
			{
			Global.runTextOut.Select(Global.runTextOut.Text.Length, 0); // move to bottom/end of output text box
			Global.runTextOut.Focus();
		}

		public static void ClearOutput() // clear Output Screen
		{
			DateTimePicker dateTime = new System.Windows.Forms.DateTimePicker();
			string dateTimeString = dateTime.Value.ToString();
			Common.DoubleSpace(); // double space for the possible benefit of the log file
			Global.runTextOut.Text = "";
			Common.WriteLn2("Output Screen: Cleared " + dateTimeString);
			Common.WriteLn(Global.runTextOut, null, Global.title + ", " + Global.version);
			if (Global.system != "") Common.WriteLn("Run on: " + Global.system);
			Common.WriteLn();
		}

		public static void HelpForm() // bring up the Help form
		{
			if (Global.helpUp < 3)			// allow at most 3 Help Forms up
			{
				HelpForm objHelpForm = new HelpForm();
				objHelpForm.Show();
				objHelpForm.Help();			// call sub Help in the Help Form
			}
		}

		private void buttonClearLogFile_Click(object sender, System.EventArgs e)
		// clear and initialize the log file
		{
			Common.ClearLog();
			SetLogCaption();
			FocusBothUs();
		}

		private void buttonClearOutput_Click(object sender, System.EventArgs e)
		// clear the output text box
		{
			ClearOutput();
		}

		private void buttonLog_Click(object sender, System.EventArgs e)
		// toggle the log screen to log file option
		{
			Common.ToggleLogg();
			FocusBothUs();
		}

		private void buttonQuit_Click(object sender, System.EventArgs e)
		// quit the Run form and go to Startup form
		{
			tQuitFlag = false;
			this.Close();		// memberFormClosing will do the work
		}

		private void buttonConfiguration_Click(object sender, System.EventArgs e)
		// bring up the configuration form
		{
			if (Common.configUp) return;
			ConfigForm objConfigForm = new ConfigForm();
			objConfigForm.Show();
			objConfigForm.Config();		// call sub Config in the Config Form
		}

		private void menuItemAbout_Click(object sender, System.EventArgs e)
		// bring up information about this program
		{
			try
			{
				AboutForm aboutForm = new AboutForm();
				aboutForm.ShowDialog();
				if (aboutForm.DialogResult == DialogResult.Cancel)
				{
					aboutForm.Dispose();
				}
			}
			catch (Exception ex)
			{
				System.Console.WriteLine(ex.Message.ToString());
			}
		}

		private void menuItemExit_Click(object sender, System.EventArgs e)
		// quit the Run form and go to Startup form
		{
			tQuitFlag = true;
			this.Close();		// memberFormClosing will do the work
		}

		private void menuItemHelpForm_Click(object sender, System.EventArgs e)
		// display the Help form
		{
			Common.DoubleSpace();
			HelpForm();
		}

		public void SetLogCaption() // set log command button Caption
		{
			if (Common.logg)
			{
				if (buttonLog.Text != "Logging Is On")
					buttonLog.Text  = "Logging Is On";
			}
			else
			{
				if (buttonLog.Text != "Logging Is Off")
					buttonLog.Text  = "Logging Is Off";
			}
		}

		private void timerRun_Tick(object sender, System.EventArgs e)
		// don't hog the processor, but don't slowdown too much
		{
			Application.DoEvents();	// process user requested actions;
		}

		private void FunctionKeys(object sender, System.Windows.Forms.KeyEventArgs e)
		// process requests from Function keys
		{
			if (e.KeyCode == Keys.F1)			// display the Help form
			{
				HelpForm();
			}
			else if (e.KeyCode == Keys.F2)		// quit program OR restart
			{
				tQuitFlag = false;
				this.Close();					// memberFormClosing will do the work
			}
			else if (e.KeyCode == Keys.F5)		// Show Data
			{
				buttonShowData_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F6)		// display Configuration form
			{
				buttonConfiguration_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F7)		// Load Data
			{
				buttonLoad_Click();
			}
			else if (e.KeyCode == Keys.F8)		// Calculate
			{
				buttonCalculate_Click();
			}
			else if (e.KeyCode == Keys.F9)		// toggle Logging OR clear Log file
			{
				if(Control.ModifierKeys != Keys.Control)
				{
					buttonLog_Click(sender, e);	// F9 toggle Logging to Log file on/off
				}
				else
				{
					buttonClearLogFile_Click(sender, e);	// Ctrl+F9 clear Log file
				}
			}
			else if (e.KeyCode == Keys.F11)		// clear output TextBox
			{
				buttonClearOutput_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F12)		// bring up the plot form
			{
				buttonPlot_Click();
			}
			else if (e.KeyCode == Keys.Escape)	// interrupt/Abort a long calculation
			{
				buttonAbortCalc_Click(sender, e);
			}
		}

		private void richTextOut_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		// function keys for output TextBox same as Run Form
		{
			FunctionKeys(sender, e);
		}

		private void RunForm_Resize(object sender, System.EventArgs e) // resize the run form
		{
			int jTop = buttonQuit.Top + buttonQuit.Height + 18;
			this.richTextOut.SetBounds(1, jTop, this.ClientRectangle.Width - 2, this.ClientRectangle.Height - jTop - 1);
		}

		private void memberFormClosing(object sender, System.ComponentModel.CancelEventArgs e)
		// the Run form is being closed so quit the Run form and go to Startup form
		// with .exe file, Close button click while running giver "Illegal operation"
		// so I put in a running test and a cancel
		{
			if (!Common.muAbort)
			{
				Common.muAbort = true;
				if (Common.running)
				{
					Common.WriteSLn("When **Running**, select Quit twice to quit");
					Global.runTextIn.Focus();
					e.Cancel = true; // cancel the Unload request
					return;
				}
			}
			if (Common.logg)
			{
				DateTimePicker dateTime = new System.Windows.Forms.DateTimePicker();
				string dateTimeString = dateTime.Value.ToString();
				Common.WriteLn("Log file " + Common.logFile + " Closed " + dateTimeString);
				Common.WriteLn(null, Common.outL);
				Common.outL.Close();
				Common.logg = false;
			}
			this.Hide();
			Global.runFormUp = false;
			if (tQuitFlag)
			{
				Dispose(true);
				objStartupForm.TotalQuit();
			}
			else
				objStartupForm.Show();
		}

		private void buttonPlot_Click(object sender, System.EventArgs e)
		// bring up the plot form
		{
			buttonPlot_Click();
		}

		private void buttonPlot_Click()
		// bring up the plot form
		{
			PlotForm objPlotForm = new PlotForm();
			objPlotForm.Show();
			objPlotForm.Plot();		// call sub Plot in the Plot Form
		}

		private bool tQuitFlag;				// total quit/exit flag
		// tQuitFlag helps implement the requirement that a close or menuItemExit will totally quit the
		// program while a Quit will go to the Startup form
		private StartupForm objStartupForm;

		public static int helpHeight = 490;		// current height of the Help Form in pixels
		public static int helpWidth = 728;		// current width of the Help Form in pixels // ??
		public static int runHeight = 564;		// current height of the Run Form in pixels
		public static int runWidth = 674;		// current width of the Run Form in pixels

		private void buttonLoad_Click(object sender, System.EventArgs e)
		{
			buttonLoad_Click();
		}

		public static void buttonLoad_Click()
		{
			string st;
			StreamReader inF;				// file number to read from
			string dir;
			string fName = Common.dataFile;
			if (fName == "") fName = "Data.txt";
			if (!Common.OpenRead(out inF, fName, out dir)) return;
			Common.WriteLn("Reading data file " + fName);
			st = "";
			while (st != null && st.IndexOf("FAC") == -1)
			{
				try { st = inF.ReadLine().ToUpper(); }
				catch { st = "FAC"; }
			}
			do			// get next line, deleting blank lines
			{
				try { st = inF.ReadLine().ToUpper(); }
				catch { st = "0"; }
				st = st.Trim();
			} while (st == "");
			FlyAKite.Param.fac1 = NextDb(ref st);
			FlyAKite.Param.fac2 = NextDb(ref st);
			FlyAKite.Param.lOW = NextDb(ref st);
			FlyAKite.Param.h = NextDb(ref st);
			while (st != null && st.IndexOf("LEN") == -1)
			{
				try { st = inF.ReadLine().ToUpper(); }
				catch { st = "LEN"; }
			}
			int i = 0;
			do			// get next line, deleting blank lines
			{
				try { st = inF.ReadLine().ToUpper(); }
				catch { st = "EOF"; }
				st = st.Trim();
			} while (st == "");
			while (st != "" && st != null && i < FlyAKite.Param.maxFlights && st.IndexOf("EOF") == -1)
			{
				i++;
				FlyAKite.Data[i].length = NextDb(ref st);
				FlyAKite.Data[i].tension = NextDb(ref st);
				FlyAKite.Data[i].zeta = NextDb(ref st);
				FlyAKite.Data[i].sA = NextDb(ref st);
				FlyAKite.Data[i].factor = NextDb(ref st);
				FlyAKite.Data[i].xKite = NextDb(ref st);
				FlyAKite.Data[i].yKite = NextDb(ref st);
				do
				{
					try { st = inF.ReadLine().ToUpper(); }
					catch { st = "EOF"; }
					st = st.Trim();
				} while (st == "");
			}
			FlyAKite.Param.lines = i;			
			FlyAKite.Param.lineN = 1;
			FlyAKite.Param.start = 1;
			FlyAKite.Param.stop = FlyAKite.Param.maxFlights;
			inF.Close();
			if (i == 0)
			{
				FlyAKite.NominalData(); // load one line of nominal data
				Common.WriteLn("File is empty, nominal data loaded");
			}
		} // buttonLoad_Click

		private static double NextDb(ref string st)
			// get next double from string
		{
			st = st.TrimStart(' ');		// delete leading blanks
			int p = st.IndexOf(' ');	// find next blank
			if (p < 0) p = st.Length;
			string s = st.Substring(0, p);
			st = st.Remove(0, p);
			try { return Convert.ToDouble(s); }
			catch { return 0.0; }
		}

		private void buttonShowData_Click(object sender, System.EventArgs e)
		{
			buttonShowData_Click();
		}

		public static void buttonShowData_Click()
		{
			Common.WriteDLn2("Flight data in memory:");
			OutputData(Common.outS, null);
			Common.WriteLn2("End");
		} // buttonShowData_Click

		public static void OutputData(RichTextBox outB, StreamWriter outF)
		{
			Common.WriteLn(outB, outF, "     Fac1     Fac2     L/W       H");
			string st = "";
			st += string.Format(" {0,9:0.00}", FlyAKite.Param.fac1);
			st += string.Format(" {0,8:0.00}", FlyAKite.Param.fac2);
			st += string.Format(" {0,8:0.0}", FlyAKite.Param.lOW);
			st += string.Format(" {0,8:0.0}", FlyAKite.Param.h);
			Common.WriteLn2(outB, outF, st);
			Common.WriteLn(outB, outF, 
				"    Len       T       Zeta      SA    Factor    XKite    YKite   Flight");
			for (int i = 1; i <= FlyAKite.Param.lines; i++)
			{
				st = "";
				st += string.Format(" {0,8:0.0}", FlyAKite.Data[i].length);
				st += string.Format(" {0,7:0.00}", FlyAKite.Data[i].tension);
				st += string.Format(" {0,9:0.000}", FlyAKite.Data[i].zeta);
				st += string.Format(" {0,8:0.000}", FlyAKite.Data[i].sA);
				st += string.Format(" {0,7:0.00}", FlyAKite.Data[i].factor);
				st += string.Format(" {0,8:0.0}", FlyAKite.Data[i].xKite);
				st += string.Format(" {0,8:0.0}", FlyAKite.Data[i].yKite);
				st += string.Format(" {0,6:0}", i);
				Common.WriteLn(outB, outF, st);
			}
		} // buttonShowData_Click

		private void buttonAbortCalc_Click(object sender, System.EventArgs e)
		{
			if (Common.abortCalc) return;
			Common.abortCalc = true;
			Common.WriteLn("Aborting calculations if any.");
		}

		private void buttonClearLogFile_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonLog_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonShowData_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonClearOutput_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonAbortCalc_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonConfiguration_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonLoad_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonCalculate_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonPlot_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonQuit_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}
	}
}
