using System;
using System.Windows.Forms; // for Application

namespace MyNamespace
{
	/// <summary>
	///		Startup form for FlyAKite program
	///		Developed in TURBO Pascal 5.5 and 6.0, converted to Visual C# .Net
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class StartupForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonRun;
		private System.Windows.Forms.Button buttonExit;
		private System.Windows.Forms.RichTextBox richTextIntro;
		private System.Windows.Forms.Button buttonDefault;
		private System.Windows.Forms.Timer timerStartup;
		private System.Windows.Forms.Label labelMaxFilghts;
		private System.Windows.Forms.TextBox textBoxMaxFlights;
		private System.ComponentModel.IContainer components;

		public StartupForm()
		{
			InitializeComponent();
			maxMaxFlights = 100000; // [1, 100000] default = 1000
			defaultFlights = 1000;
			SetDefault();
			this.Text = Global.title + " - Startup";
			Pr("");
			Pr("   " + Global.name1);
			Pr("   " + Global.name2);
			Pr("   " + Global.version);
			Pr("   " + Global.author);
			Pr("   " + Global.address);
			Pr("");
			Pr("FlyAKite is a kite-flying program with the following features:");
			Pr("");
			Pr("     Allows for flight data files input, edit, and update");
			Pr("     Displays flight data");
			Pr("     Can save all displayed data to a log file");
			Pr("     Allows for entering integration parameters");
			Pr("     Computes wind factors for flight data file");
			Pr("     Uses differential equations to solve for position and tension");
			Pr("        vectors as a function of arc length");
			Pr("     Uses Runge-Kutta method for integration of ordinary differential");
			Pr("        equations");
			Pr("     Plots string trajectory/profile on hires screen");
			Pr("     Plots analytical continuation of the string trajectory");
			Pr("     Allows for printer output of help file");
			Pr("     And more...");
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(StartupForm));
			this.richTextIntro = new System.Windows.Forms.RichTextBox();
			this.buttonRun = new System.Windows.Forms.Button();
			this.buttonExit = new System.Windows.Forms.Button();
			this.labelMaxFilghts = new System.Windows.Forms.Label();
			this.textBoxMaxFlights = new System.Windows.Forms.TextBox();
			this.buttonDefault = new System.Windows.Forms.Button();
			this.timerStartup = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// richTextIntro
			// 
			this.richTextIntro.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(208)), ((System.Byte)(244)), ((System.Byte)(255)));
			this.richTextIntro.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.richTextIntro.ForeColor = System.Drawing.Color.Blue;
			this.richTextIntro.Location = new System.Drawing.Point(0, -8);
			this.richTextIntro.Name = "richTextIntro";
			this.richTextIntro.ReadOnly = true;
			this.richTextIntro.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.None;
			this.richTextIntro.Size = new System.Drawing.Size(464, 480);
			this.richTextIntro.TabIndex = 7;
			this.richTextIntro.Text = "";
			this.richTextIntro.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// buttonRun
			// 
			this.buttonRun.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.buttonRun.Location = new System.Drawing.Point(480, 432);
			this.buttonRun.Name = "buttonRun";
			this.buttonRun.Size = new System.Drawing.Size(40, 24);
			this.buttonRun.TabIndex = 0;
			this.buttonRun.Text = "Run";
			this.buttonRun.Click += new System.EventHandler(this.buttonRun_Click);
			this.buttonRun.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// buttonExit
			// 
			this.buttonExit.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.buttonExit.Location = new System.Drawing.Point(536, 432);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.Size = new System.Drawing.Size(40, 23);
			this.buttonExit.TabIndex = 1;
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			this.buttonExit.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// labelMaxFilghts
			// 
			this.labelMaxFilghts.Location = new System.Drawing.Point(472, 192);
			this.labelMaxFilghts.Name = "labelMaxFilghts";
			this.labelMaxFilghts.Size = new System.Drawing.Size(120, 16);
			this.labelMaxFilghts.TabIndex = 3;
			this.labelMaxFilghts.Text = "Max Flights/Data File";
			// 
			// textBoxMaxFlights
			// 
			this.textBoxMaxFlights.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBoxMaxFlights.Location = new System.Drawing.Point(496, 208);
			this.textBoxMaxFlights.Name = "textBoxMaxFlights";
			this.textBoxMaxFlights.Size = new System.Drawing.Size(72, 20);
			this.textBoxMaxFlights.TabIndex = 5;
			this.textBoxMaxFlights.Text = "1000";
			this.textBoxMaxFlights.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			this.textBoxMaxFlights.TextChanged += new System.EventHandler(this.textBoxMaxFlights_TextChanged);
			// 
			// buttonDefault
			// 
			this.buttonDefault.Location = new System.Drawing.Point(480, 280);
			this.buttonDefault.Name = "buttonDefault";
			this.buttonDefault.Size = new System.Drawing.Size(104, 24);
			this.buttonDefault.TabIndex = 6;
			this.buttonDefault.Text = "Default Settings";
			this.buttonDefault.Click += new System.EventHandler(this.buttonDefault_Click);
			this.buttonDefault.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// timerStartup
			// 
			this.timerStartup.Enabled = true;
			this.timerStartup.Tick += new System.EventHandler(this.timerStartup_Tick);
			// 
			// StartupForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(600, 470);
			this.Controls.Add(this.buttonDefault);
			this.Controls.Add(this.textBoxMaxFlights);
			this.Controls.Add(this.labelMaxFilghts);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.buttonRun);
			this.Controls.Add(this.richTextIntro);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "StartupForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "<App.Title> - Startup";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.memberFormClosing);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args) // get command line arguments and bring up the frame
		{
			new Global();	// initialize class Global
			Global.parmsDone = true;	// don't process command line arguments
			StartupForm objStartupForm = new StartupForm();
			startupTicks = 1;
			if (!objStartupForm.IsDisposed) Application.Run(objStartupForm);
		}

		private void Pr(string st)
		{
			richTextIntro.Text += "   " + st + "\n";
		}

		private void textBoxMaxFlights_TextChanged(object sender, System.EventArgs e)
		// max flights in a data file [1, maxMaxFlights]
		{
			string sNum = textBoxMaxFlights.Text.TrimStart(' ');	// remove leading spaces
			textBoxMaxFlights.Text = sNum;							// from text box
			if (Global.IsInt32(sNum))
			{
				int iNum = System.Convert.ToInt32(sNum);
				bMaxFlights = (1 <= iNum) && (iNum <= maxMaxFlights);
			}
			else
			{
				bMaxFlights = false;
			}
			int n = sNum.Length;
			if (n > 0 && sNum[n-1] == ' ') // remove space at end
			{
				sNum = sNum.TrimEnd(' ');
				textBoxMaxFlights.Text = sNum;
				textBoxMaxFlights.SelectionStart = sNum.Length; // stay at end
			}
			SetFonts();
		}

		private void buttonDefault_Click(object sender, System.EventArgs e)
		{
			SetDefault();
		}

		private void SetDefault()
		{
			textBoxMaxFlights.Text = defaultFlights.ToString();
			buttonRun.Enabled = bMaxFlights = true;
		}

		private void buttonRun_Click(object sender, System.EventArgs e)
		// start running the program
		{
			buttonRunProg();
		}

		private void buttonRunProg() // start running the program
		{
			int iMaxFlights = System.Convert.ToInt32(textBoxMaxFlights.Text);
			this.Hide();
			RunForm objRunForm = new RunForm();
			objRunForm.Show();
			objRunForm.Run(iMaxFlights, this); // call sub Run in the form frmRun
		}

		private void SetFonts()
		{
			if (bMaxFlights)
				this.textBoxMaxFlights.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxMaxFlights.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			buttonRun.Enabled = bMaxFlights;
		}

		public void TotalQuit()
		{
			Dispose(true);
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		{
			Dispose(true);
		}

		private void buttonRun_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape)		// ESC key pressed so Exit Startup
			{
				Dispose(true);
			}
		}

		private void timerStartup_Tick(object sender, System.EventArgs e)
		{
			if (startupTicks > 0) startupTicks++;
			if (startupTicks > 100)
				timerStartup.Enabled = false;	// and then only needed once
		}

		private void memberFormClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			Dispose(true);
		}

		private static bool bMaxFlights;		// MaxFlights good flag
		private static int defaultFlights;		// MaxFlights default
		private static int maxMaxFlights;		// maxMaxFlights allowed
		private static int startupTicks = 0;
	}
}
